#include <iostream>
#include <cstdlib>
#include <queue>
#include <vector>
#include <map>
#include <algorithm>

#define Mod 1000000009LL
#define Base 1093
using namespace std;

string s;
int q;
map<long long, int> hashes;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    cin >> q;

    int sz = s.size();
    long long Bton = 1LL;
    long long cntsub = 0;

    for(int len = 1; len <= sz; len ++)
    {
        long long curh = 0;

        for(int i = 0; i < sz; i ++)
        {
            if(i < len) curh = (curh * Base + (s[i] - 'a' + 1)) % Mod;
            else
            {
                curh -= ((s[i - len] - 'a' + 1) * Bton) % Mod;
                if(curh < 0) curh += Mod;
                curh = (curh * Base + (s[i] - 'a' + 1)) % Mod;
            }

            if(i >= len - 1)
            {
                if(hashes.count(curh) == 0) cntsub ++;
                hashes[curh] ++;
            }
        }
        Bton *= Base;
    }
    cout << cntsub << endl;

    return 0;
}
