#include <iostream>
#include <cstdlib>
#include <queue>
#include <vector>
#include <map>
#include <algorithm>

#define Mod1 1000000007LL
#define Mod2 1000000009LL
#define Base 149LL
using namespace std;

string s;
int q;
map<long long, int> hashes1, hashes2;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    cin >> q;

    int sz = s.size();
    long long Bton1 = 1LL, Bton2 = 1LL;
    long long cntsub = 0;

    for(int len = 1; len <= sz; len ++)
    {
        long long curh1 = 0, curh2 = 0;
        hashes1.clear();
        hashes2.clear();

        for(int i = 0; i < sz; i ++)
        {
            if(i < len) curh1 = (curh1 * Base + (s[i] - 'a' + 1)) % Mod1,
                        curh2 = (curh2 * Base + (s[i] - 'a' + 1)) % Mod2;
            else
            {
                curh1 -= ((s[i - len] - 'a' + 1) * Bton1) % Mod1;
                curh2 -= ((s[i - len] - 'a' + 1) * Bton2) % Mod2;
                if(curh1 < 0) curh1 += Mod1;
                if(curh2 < 0) curh2 += Mod2;
                curh1 = (curh1 * Base + (s[i] - 'a' + 1)) % Mod1;
                curh2 = (curh2 * Base + (s[i] - 'a' + 1)) % Mod2;
            }

            if(i >= len - 1)
            {
                if(hashes1.count(curh1) == 0 && hashes2.count(curh2) == 0) cntsub ++;
                hashes1[curh1] ++;
                hashes2[curh2] ++;
            }
        }
        Bton1 *= Base;
        Bton1 %= Mod1;
        Bton2 *= Base;
        Bton2 %= Mod2;

    }
    cout << cntsub << endl;

    return 0;
}
