#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int MAXN = 1500005;

int n, s, t;
pair<int, int> a[MAXN];

void Init()
{
    cin >> n >> s >> t;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i].first >> a[i].second;
    }
}

int opt = 0;
vector<int> v;
vector<vector<int>> all;

vector<int> uch[2], muz[2], ezi[2];
int cntL[MAXN], cntM[MAXN], cntR[MAXN];

void Rec(int x = 1)
{
    if (x == n + 1)
    {
        if (v.size() > opt)
        {
            opt = v.size();
            all.clear();
        }
        if (v.size() == opt) all.push_back(v);
        return;
    }

    bool can = true;
    for (int i = 0; i < v.size(); ++ i)
    {
        if (a[x].first == a[v[i]].first or a[x].second == a[v[i]].second)
        {
            can = false;
            break;
        }
    }

    Rec(x + 1);
    if (can)
    {
        v.push_back(x);
        Rec(x + 1);
        v.pop_back();
    }
}

int main()
{
    Init();
    Rec();


    for (int i = 0; i < all.size(); ++ i)
    {
        for (int j = 0; j < all[i].size(); ++ j)
        {
            cntM[all[i][j]]++;
            cntL[a[all[i][j]].first]++;
            cntR[a[all[i][j]].second]++;
        }
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (cntM[i] == all.size()) uch[0].push_back(i);
        if (cntM[i] == 0) uch[1].push_back(i);
    }

    for (int i = 1; i <= s; ++ i)
    {
        if (cntL[i] == all.size()) ezi[0].push_back(i);
        if (cntL[i] == 0) ezi[1].push_back(i);
    }

    for (int i = 1; i <= t; ++ i)
    {
        if (cntR[i] == all.size()) muz[0].push_back(i);
        if (cntR[i] == 0) muz[1].push_back(i);
    }

    cout << opt << ' ' << uch[0].size() << ' ' << uch[1].size() << ' ' << ezi[0].size() << ' ' << ezi[1].size() << ' ' << muz[0].size() << ' ' << muz[1].size() << endl;
    for (int x : uch[0]) cout << x << ' ';
    cout << endl;
    for (int x : uch[1]) cout << x << ' ';
    cout << endl;
    for (int x : ezi[0]) cout << x << ' ';
    cout << endl;
    for (int x : ezi[1]) cout << x << ' ';
    cout << endl;
    for (int x : muz[0]) cout << x << ' ';
    cout << endl;
    for (int x : muz[1]) cout << x << ' ';
    cout << endl;

    return 0;
}
