#include <iostream>
#include <iomanip>
#include <math.h>

using namespace std;

struct circle
{
    double x, y, r;
} circles [100];

double surface (circle a, circle b, circle c)
{
    double Bx, By, Cx, Cy;
    Bx = b.x - a.x;
    By = b.y - a.y;
    Cx = c.x - a.x;
    Cy = c.y - a.y;
    //cout << "Surface=" << abs(Bx*Cy+By*Cx)/2<< endl;
    return abs ((Bx*Cy+By*Cx))/2;
}

double abc (circle a, circle b, circle c)
{
    double Bx, By, Cx, Cy;
    Bx = b.x - a.x;
    By = b.y - a.y;
    Cx = c.x - a.x;
    Cy = c.y - a.y;
    //cout << "a2b2c2 = " << ((Cx*Cx+Cy*Cy)*(Bx*Bx+By*By)*((Bx-Cx)*(Bx-Cx)+(By-Cy)*(By-Cy))) << endl;
    return sqrt ((Cx*Cx+Cy*Cy)*(Bx*Bx+By*By)*((Bx-Cx)*(Bx-Cx)+(By-Cy)*(By-Cy)));
}

double R (circle a, circle b, circle c)
{
    double value = (abc (a, b, c) / (4 * surface (a, b, c)));
    //cout << "R = " << value << endl;
    return value;
}

int main ()
{
    cin.tie (nullptr);
    ios::sync_with_stdio (false);
    int n;
    cin >> n;
    for (int i = 0 ; i < n ; i ++)
    {
        cin >> circles [i].x >> circles [i].y >> circles [i].r;
    }
    //cout << R (circles [0], circles [2], circles [5]) - max (circles [0].r, max (circles [2].r, circles [5].r)) << endl;
    double maxR = 0;
    for (int i = 0 ; i < n ; i ++)
    for (int j = i + 1 ; j < n ; j ++)
    for (int k = j + 1 ; k < n ; k ++)
    {
        double r = R (circles [i], circles [j], circles [k]) - max (circles [i].r, max (circles [j].r, circles [k].r));
        //cout << r << endl;
        maxR = max (maxR, r);
    }
    cout << setprecision (9) << maxR << endl;
    return 0;
}
