#include <bits/stdc++.h>
using namespace std;
vector <int> build_suff (string s){
    int n = s.size (), classes = 1;
    vector <int> p (n), c (n), br (max (n, 256), 0);
    for (int i = 0; i < n; i ++) br [s [i]] ++;
    for (int i = 1; i < 256; i ++) br [i] += br [i - 1];
    for (int i = 0; i < n; i ++) p [--br [s [i]]] = i;
    c [p [0]] = 0;
    for (int i = 1; i < n; i ++){
        if (s [p [i]] == s [p [i - 1]]) c [p [i]] = classes - 1;
        else c [p [i]] = classes ++;
    }
    vector <int> p1 (n), c1 (n);
    for (int k = 1; (1 << k) < n; k ++){
        for (int i = 0; i < n; i ++) p1 [i] = (p [i] + n - (1 << k)) % n;
        for (int i = 0; i < classes; i ++) br [i] = 0;
        for (int i = 0; i < n; i ++) br [c [i]] ++;
        for (int i = 1; i < classes; i ++) br [i] += br [i - 1];
        for (int i = n - 1; i >= 0; i --) p [--br [c [p1 [i]]]] = p1 [i];
        c1 [p [0]] = 0;
        classes = 1;
        for (int i = 1; i < n; i ++){
            pair <int, int> curr = {c [p [i]], c [(p [i] + (1 << k)) % n]};
            pair <int, int> prev = {c [p [i - 1]], c [(p [i - 1] + (1 << k)) % n]};
            if (curr == prev) c1 [p [i]] = classes - 1;
            else c1 [p [i]] = classes ++;
        }
        c = c1;
    }
    return p;
}
vector <int> build_lcp (string s, vector <int> p){
    int n = s.size ();
    vector <int> pos (n), lcp (n - 1);
    for (int i = 0; i < n; i ++) pos [p [i]] = i;
    int k = 0;
    for (int i = 0; i < n; i ++){
        if (pos [i] == n - 1){
            k = 0;
            continue;
        }
        int j = p [pos [i] + 1];
        while (s [i + k] == s [j + k]) k ++;
        lcp [pos [i]] = k;
        if (k) k --;
    }
    return lcp;
}
int n, q;
string s;
vector <int> suff, lcp;
int main (){

	ios::sync_with_stdio (false);
	cin.tie (0);

	cin >> s >> q;
    n = s.size ();
    s += "$";
    suff = build_suff (s);
    lcp = build_lcp (s, suff);
    long long br = n - suff [0];
    for (int i = 1; i < n; i ++){
        br += n - suff [i] - lcp [i - 1];
    }
    cout << br << '\n';

}
