#pragma GCC optimize "Ofast"
#include <iostream>
#include <unordered_map>
#include <bitset>
#include <cstring> // memset
using namespace std;

typedef unsigned long long ull;
//typedef unsigned int ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

//const ull MOD = 1e9 + 7;
const ull BASE = 127;
const int MAX_NPQ = 5e3 + 204;
ull mem[MAX_NPQ][MAX_NPQ];
std::unordered_map<ull, unsigned int> map[MAX_NPQ];
unsigned long long ans = 0;

void modOp1() {
	for(int len = 1;len < inp.size()-from+1;len ++) {
		ull hash = mem[len-1][inp.size()-len];
		hash *= BASE;
		hash += inp[inp.size()-1];
		mem[len][inp.size()-len] = hash;

		if(map[len][hash] == 0) ans ++;
		map[len][hash] ++;
	}
}

void modOp2() {
	for(int len = 1;len < inp.size()-from+2;len ++) {
		ull hash = mem[len][from-1];
		map[len][hash] --;
		if(map[len][hash] == 0) ans --;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string spam;
	cin >> spam;
	for(int i = 0;i < spam.size();i ++) {
		inp += spam[i];
		modOp1();
	}

	cout << ans << ' ';

	int Q; cin >> Q;
	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			modOp1();
			cout << ans << ' ';
		} else {
			from ++;
			modOp2();
			cout << ans << ' ';
		}
	}
	return 0;
}
