#include<iostream>
#include<cstring>
#include<vector>

using namespace std;

const int MAXN = 1e5 + 5;

int cnt[MAXN];

int L, R;
int c[MAXN];

struct Trie
{
    int endOf = -1;

    Trie *children[30];

    Trie()
    {
        for(int c = 0;c<30;c++) this->children[c] = nullptr;
    }
};
Trie *T = new Trie();

void addSting()
{
    Trie *curr = T;
    for(int i = R;i>=L;i--)
    {
        if(curr->children[ c[i] ]==nullptr)
        {
            curr->children[ c[i] ] = new Trie();
        }

        curr = curr->children[ c[i] ];
        /*
        if(curr->endOf!=-1)
        {
            cnt[curr->endOf]--;
            cnt[i]++;

            curr->endOf = i;
        }
        else
        {
            cnt[i]++;
            curr->endOf = i;
        }
        */
    }
}

long long calcAns()
{
    long long ans = 0;
    for(int i = L;i<=R;i++)
    {
        ans += cnt[i];
        //cout << i << " -> " << cnt[i] << '\n';
    }

    return ans;
}

void printVector(vector <long long> &v)
{
    if(v.size()==0)
    {
        cout << '\n';
        return;
    }

    cout << v[0];
    for(int i = 1;i<v.size();i++) cout << " " << v[i];
    cout << '\n';
}

void read()
{
    string input;
    cin >> input;

    L = 0;
    for(int i = 0;i<input.size();i++)
    {
        R = i;
        c[i] = input[i] - 'a';

        addSting();
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    vector <long long> answer;

    read();

    /*
    L = 0;
    while(true)
    {
        char x;
        cin.get(x);
        if(x=='\n') break;

        c[R] = x;
        addSting();

        R++;
    }
    R--;
    */

    /*
    L = 0, R = 0;
    for(int i = 0;i<strlen(c);i++)
    {
        addSting();
        R++;
    }
    R--;
    */

    return 0;

    answer.push_back(calcAns());

    int Q;
    cin >> Q;
    while(Q--)
    {
        int type;
        cin >> type;

        if(type==1)
        {
            char newChar;
            cin >> newChar;

            R++;
            c[R] = newChar - 'a';

            addSting();
        }
        else
        {
            L++;
        }

        answer.push_back(calcAns());
    }

    printVector(answer);
}
