#include<bits/stdc++.h>
using namespace std;
int const maxn = 5*1e3;

map<pair<int,int>,bool>mp;
int base[2] = {29,31};
int mod[2] = {int(1e9+7),int(1e9+9)};
int p[maxn][2];

void pow()
{
    int i;
    p[0][0] = 1;
    p[0][1] = 1;


    for(i=1;i<maxn;i++)
    {
        p[i][0] = (p[i-1][0]*base[0])%mod[0];
        p[i][1] = (p[i-1][1]*base[1])%mod[1];
    }
}

int check(int t0, int t1)
{
    if(!mp[{t0,t1}])
    {
        mp[{t0,t1}] = true;
        return 1;
    }

    return 0;
}

int h[maxn][2];
void hashing(string s)
{
    int i,sz=s.size();
    h[0][0] = h[0][1] = 0;
    for(i=1;i<=sz;i++)
    {
        h[i][0] = (h[i-1][0] * base[0] + s[i-1] - 'a' + 1)%mod[0];
        h[i][1] = (h[i-1][1] * base[1] + s[i-1] - 'a' + 1)%mod[1];
    }
}
vector<long long>v;

void solve(string s)
{
    long long ans = 0;
    int i,sz=s.size(),j;
    mp.clear();
    hashing(s);

    for(i=1;i<=sz;i++)
    {
        int t0,t1;

        for(j=i;j<=sz;j++)
        {
            t0 = (h[j][0] - h[j-i][0]*p[i][0])%mod[0]; t0 = (t0+mod[0])%mod[0];
            t1 = (h[j][1] - h[j-i][1]*p[i][1])%mod[1]; t1 = (t1+mod[1])%mod[1];
            //cout<<h[j]<<" "<<h[j-i]<<" "<<p[i]<<" ";
            ans += check(t0,t1);
            //cout<<t<<"\n";
        }
        //cout<<endl;
    }

    v.push_back(ans);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    int q,i,t;
    char c;
    pow();
    cin>>s;
    solve(s);

    cin>>q;
    for(i=0;i<q;i++)
    {
        cin>>t;

        if(t == 1)
        {
            cin>>c;
            s = s + c;
        }
        else
        {
            s = s.erase(0,1);
        }
        //cout<<s<<endl;
        solve(s);
    }

    for(i=0;i<v.size();i++)
        cout<<v[i]<<" ";
    cout<<"\n";

    return 0;
}
