#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef long double ld;
const ld  eps=1e-9;
const ld inf=1e9;
struct TEC
{
    ld  x,y,r;
    TEC() {}
    TEC(ld  _x,ld  _y,ld  _r)
    {
        x=_x;
        y=_y;
        r=_r;
    }

} cir[128];
int n;
ld  dist(ld x1,ld y1,ld x2,ld y2)
{
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}
ld R(ld x,ld y)
{
    ld minr=inf;
    for(int i=0; i<n; i++)
    {
        int d=dist(cir[i].x,cir[i].y,x,y);
        d-=cir[i].r;
        if(d<minr)
            minr=d;
    }
    return minr;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for(int i=0; i<n; i++)
    {
        cin>>cir[i].x>>cir[i].y>>cir[i].r;
    }
    ld  x,y,ans=0;
    srand(6922092002);
    for(int a=0; a<500000; a++)
    {
        ///cout<<x<<" "<<y<<endl;
        if(a==0)
            x=1000,y=0;
        if(a==1)
            x=1000,y=1000;
        if(a==2)
            x=0,y=0;
        if(a==3)
            x=0,y=1000;
        if(a>3)
        {
            x=(rand()*rand()*rand()/inf+(rand()%1000));
            x+=rand()*rand()/inf;
            y=(rand()*rand()*rand()/inf+(rand()%1000));
            y+=rand()*rand()/inf;
        }
        ld  newr=R(x,y);
        if(newr>ans)
        {
            ans=newr;
        }
    }
    cout<<fixed<<setprecision(9)<<ans<<endl;
    return 0;
}
