#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define pii pair <int, int>
#define endl '\n'
using namespace std;
const int N = 1e5 + 5;
double TL = 0.7;

bool TimeOK()
{
    return clock() < (double)TL * CLOCKS_PER_SEC;
}


int n, s, t;
vector <pii> e;
vector <int> nb[N];

bool banned_e[N], banned_s[N], banned_t[N];
int matched[N], vis[N], timestamp;
pii god_match;
int DFS(int v)
{
    if(vis[v] == timestamp)
        return 0;
    if(v == god_match.first || v == god_match.second)
        return 0;
    if(banned_s[v])
        return 0;

    vis[v] = timestamp;
    for(int id: nb[v])
    {
        if(banned_e[id])
            continue;
        if(banned_t[e[id].second])
            continue;

        if((matched[e[id].second] == -1) || DFS(matched[e[id].second]))
        {
            matched[e[id].second] = v;
            return 1;
        }
    }

    return 0;
}

int Kuhn()
{
    int res = 0;
    memset(matched, -1, sizeof(matched));
    for(int i = 1; i <= s; i++)
    {
        timestamp++;
        if(DFS(i))
            res++;
    }
    return res;
}

vector <int> always[3], never[3];

int main()
{
    cin.tie(NULL); cout.tie(NULL);
    ios_base::sync_with_stdio(false);

    cin >> n >> s >> t;
    for(int i = 1; i <= n; i++)
    {
        pii x;
        cin >> x.first >> x.second;
        nb[x.first].pb((int)e.size());
        e.pb(x);
    }

    int max_team = Kuhn();

    for(int i = 1; i <= n; i++)
    {
        banned_e[i - 1] = true;
        if(Kuhn() != max_team)
            always[0].pb(i);

        banned_e[i - 1] = false;
    }
    for(int i = 1; i <= n; i++)
    {
        god_match = e[i - 1];
        if(Kuhn() < max_team - 1)
            never[0].pb(i);
        god_match = mp(-1, -1);
    }

    for(int i = 1; i <= s; i++)
    {
        banned_s[i] = true;
        if(Kuhn() < max_team)
            always[1].pb(i);
        banned_s[i] = false;
    }

    for(int i = 1; i <= t; i++)
    {
        banned_t[i] = true;
        if(Kuhn() < max_team)
            always[2].pb(i);
        banned_t[i] = false;
    }

    cout << max_team << ' ';
    for(int i = 0; i < 3; i++)
        cout << always[i].size() << ' ' << never[i].size() << ' ';
    cout << endl;
    for(int i = 0; i < 3; i++)
    {
        for(int x: always[i])
            cout << x << ' ';
        cout << endl;
        for(int x: never[i])
            cout << x << ' ';
        cout << endl;
    }

    return 0;
}

/*

6 4 5
1 1
2 1
3 2
3 3
3 4
4 4

*/
