#include <bits/stdc++.h>
using namespace std;
//T+N
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll mod = 1e9 + 7;
template<class T, class T2> inline bool chkmax(T &a, const T2 &b) {return a < b ? a = b, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &a, const T2 &b) {return a > b ? a = b, 1 : 0;}
template<class T> inline void fix(T &a) {if(a >= mod | a <= -mod) {a %= mod;} if(a < 0) {a += mod;}}
//#pragma GCC optimize("Ofast")

ld dist(ld x, ld y, ld a, ld b) {
    return (x - a) * (x - a) + (y - b) * (y - b);
}

ld sqr(ld x, ld y, ld a, ld b) {
    return sqrt(dist(x, y, a, b));
}

const int MAX_N = 110;
struct Point {
    ld x, y, rad;
    bool operator<(const Point &other) const {
        return y < other.y;
    }
};
Point p[MAX_N];
ld x[MAX_N], y[MAX_N], rad[MAX_N];
int n;

bool cmp(const Point &a, const Point &b) {
    return a.x < b.x;
}

ld ret = 0;

ld f(ld a, ld b) {
    if(b > 1000) {return -mod;}
    ld best = mod;
    for(int i = 1; i <= n; i ++) {
        ld curr = sqr(a, b, x[i], y[i]) - rad[i];
        chkmin(best, curr);
        if(best < 1e-9) {return 0;}
    }
    if(chkmax(ret, best)) {
        //cout << a << " " << b << endl;
    }
    return best;
}

ld line(ll x) {
    ld best = 0;
    for(int i = 0; i < n + 2; i ++) {
        ld l = y[i], r = y[i + 1];
        f(x, l);
        f(x, r);
        for(ll iter = 0; iter < 30; iter ++) {
            ld m1 = (l + r) / 3.f, m2 = (l + r) * 2.f / 3.f;
            ld lft = f(x, m1);
            ld rght = f(x, m2);
            chkmax(best, lft);
            chkmax(best, rght);
            if(f(x, m1) < f(x, m2)) {
                l = m1;
            } else {
                r = m2;
            }
        }
    }
    return best;
}

const ld eps = 1e-9;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> p[i].x >> p[i].y >> p[i].rad;
    }
    sort(p, p + n);
    x[0] = y[0] = 0;
    x[n + 1] = y[n + 1] = 1000;
    for(int i = 0; i < n; i ++) {
        x[i + 1] = p[i].x;
        y[i + 1] = p[i].y;
        rad[i + 1] = p[i].rad;
    }
    sort(p, p + n, cmp);
    for(ld a = 0; clock() / CLOCKS_PER_SEC < 0.55 && a <= 1000;) {
        ld now = line(a);
        //cout << a << endl;
        if(abs(now - ret) <= eps) {
            a += 0.1;
        } else {
            a += (ret - now) / 10.f;
        }
    }
    cout << fixed << setprecision(10);
    cout << ret << endl;
    return 0;
}

