#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

struct circle
{
    double x, y, r;
};

const int maxn = 103;
const double eps = 0.000001;
const double pi = acos(-1);

int n;
circle circles[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    cin >> circles[i].x >> circles[i].y >> circles[i].r;
}
double find_range(double x, double y)
{
    double ans = min(min(x, 1000.0-x), min(y, 1000.0-y));
    for (int k = 1; k <= n; k++)
    {
        double r = sqrt((x - circles[k].x) * (x - circles[k].x) + (y - circles[k].y) * (y - circles[k].y)) - circles[k].r;
        ans = min(ans, r);
    }

    return ans;
}

void solve()
{
    double ans = 0;
    for (double i = 0; i <= 1000.0; i += 0.05)
    for (double j = 0; j <= 1000.0; j += 0.05)
    ans = max(ans, find_range(i, j));

    cout << fixed;
    cout << setprecision(12) << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8
*/
