#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

const int maxn = 2e5 + 3;
const int base = 29;
const int mod = 1e9 + 7;

string s;
int q, sz;
void read()
{
    cin >> s >> q;
    sz = (int)s.size();
}

long long pr[maxn], base_pow[maxn];
long long get(int l, int r)
{
    return (pr[r] - pr[l-1] * base_pow[r-l+1] % mod + mod) % mod;
}

int lcp(int i, int j)
{
    int low = 0, high = sz - max(i, j) + 1;
    while (low < high)
    {
        int mid = (low + high + 1) / 2;
        if (get(i, i + mid - 1) == get(j, j + mid - 1))
            low = mid;

        else
            high = mid - 1;
    }

    return low;
}

bool cmp(int i, int j)
{
    int curr_lcp = lcp(i, j);
    if (curr_lcp == sz - max(i, j) + 1)
        return i < j;

    return s[i + curr_lcp - 1] < s[j + curr_lcp - 1];
}

long long get(int l)
{
    vector <int> v;
    for (int i = l; i <= sz; i++)
        v.push_back(i);

    sort (v.begin(), v.end(), cmp);

    long long ans = (sz - l + 1) * (sz - l + 2) / 2;
    for (int i = 0; i < sz - l; i++)
    ans -= lcp(v[i], v[i+1]);

    return ans;
}

void solve()
{
    for (int i = 1; i <= sz; i++)
        pr[i] = (pr[i-1] * base + s[i-1] - 'a') % mod;

    base_pow[0] = 1;
    for (int i = 1; i < maxn; i++)
        base_pow[i] = base_pow[i-1] * base % mod;

    int l = 1;
    cout << get(l) << " ";
    while (q--)
    {
        int type;
        cin >> type;

        if (type == 2)
            l++;

        else
        {
            char let;
            cin >> let;

            sz++;
            s += let;
            pr[sz] = (pr[sz-1] * base + s[sz-1] - 'a') % mod;
        }

        cout << get(l) << " ";
    }

    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
