#include <iostream>
#include <cstdlib>
#include <queue>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

struct kid
{
    int la, in;

    kid(){};
    kid(int a, int b)
    {
        la = a, in = b;
    }
} kids[15];

int n, s1, t, maxcnt;
int always[15], never[15];
int instral[15], instrne[15];
int langal[15], langne[15];

void rec(string s)
{
    if(s.size() == n)
    {
        int cnt = 0;
        bool ok = 1;
        bool instr[15], lang[15];
        for(int i = 0; i < 15; i ++)
            instr[i] = 0, lang[i] = 0;
        for(int i = 0; i < n ; i ++)
        {
            if(s[i] == '1')
            {
                cnt ++;

                if(instr[kids[i].in] == 1)
                {
                    ok = 0;
                    break;
                }
                else instr[kids[i].in] = 1;
                if(lang[kids[i].la] == 1)
                {
                    ok = 0;
                    break;
                }
                else lang[kids[i].la] = 1;
            }
            else continue;
        }
        if(ok == 0) return ;

        if(cnt > maxcnt)
        {
            maxcnt = cnt;
            for(int i = 0; i < n; i ++)
                always[i] = 1, never[i] = 1;

            for(int i = 1; i <= t; i ++)
                langal[i] = 1, langne[i] = 1;

            for(int i = 1; i <= s1; i ++)
                instral[i] = 1, instrne[i] = 1;

        }
        else if(cnt == maxcnt)
        {
            for(int i = 0; i < n; i ++)
            {
                if(always[i] == 1 && s[i] == '0')
                    always[i] = 0;
                if(never[i] == 1 && s[i] == '1')
                    never[i] = 0;
            }
            for(int i = 1; i <= s1; i ++)
            {
                if(instral[i] == 1 && instr[i] == 0)
                    instral[i] = 0;
                if(instrne[i] == 1 && instr[i] == 1)
                    instrne[i] = 0;
            }
            for(int i = 1; i <= t; i ++)
            {
                if(langal[i] == 1 && lang[i] == 0)
                    langal[i] = 0;
                if(langne[i] == 1 && lang[i] == 1)
                    langne[i] = 0;
            }
        }

        return ;
    }

    rec(s + "0");
    rec(s + "1");
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> s1 >> t;

    for(int i = 0; i < n; i ++)
        cin >> kids[i].in >> kids[i].la;

    rec("");

    cout << maxcnt << " ";
    int cntal = 0, cntne = 0;
    int cntinal = 0, cntinne = 0;
    int cntlaal = 0, cntlane = 0;
    for(int i = 0; i < n; i ++)
    {
        if(always[i] == 1) cntal ++;
        if(never[i] == 1) cntne ++;
    }
    for(int i = 1; i <= s1; i ++)
    {
        if(instral[i] == 1) cntinal ++;
        if(instrne[i] == 1) cntinne ++;
    }
    for(int i = 1; i <= t; i ++)
    {
        if(langne[i] == 1) cntlane ++;
        if(langal[i] == 1) cntlaal ++;
    }

    cout << cntal << " " << cntne << " " << cntinal << " " << cntinne << " " << cntlaal << " " << cntlane;
    cout << endl;

    for(int i = 0; i < n; i ++)
        if(always[i] == 1) cout << i + 1 << " ";
    cout << endl;

    for(int i = 0; i < n; i ++)
        if(never[i] == 1) cout << i + 1 << " ";
    cout << endl;

    for(int i = 1; i <= s1; i ++)
        if(instral[i] == 1) cout << i << " ";
    cout << endl;

    for(int i = 1; i <= s1; i ++)
        if(instrne[i] == 1) cout << i << " ";
    cout << endl;

    for(int i = 1; i <= t; i ++)
        if(langal[i] == 1) cout << i << " ";
    cout << endl;

    for(int i = 1; i <= t; i ++)
        if(langne[i] == 1) cout << i << " ";
    cout << endl;
    return 0;
}
