#include <iostream>
#include <cstdlib>
#include <queue>
#include <vector>
#include <map>
#include <algorithm>

#define Mod1 1000000007LL
#define Mod2 1000000009LL
#define Base 149LL
using namespace std;

string s;
int q;
map<long long, int> hashes1[1501], hashes2[1501];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> s;
    cin >> q;

    int sz = s.size();
    long long Bton1 = 1LL, Bton2 = 1LL;
    long long cntsub = 0;

    for(int len = 1; len <= sz; len ++)
    {
        long long curh1 = 0, curh2 = 0;

        for(int i = 0; i < sz; i ++)
        {
            if(i < len) curh1 = (curh1 * Base + (s[i] - 'a' + 1)) % Mod1,
                        curh2 = (curh2 * Base + (s[i] - 'a' + 1)) % Mod2;
            else
            {
                curh1 -= ((s[i - len] - 'a' + 1) * Bton1) % Mod1;
                curh2 -= ((s[i - len] - 'a' + 1) * Bton2) % Mod2;
                if(curh1 < 0) curh1 += Mod1;
                if(curh2 < 0) curh2 += Mod2;
                curh1 = (curh1 * Base + (s[i] - 'a' + 1)) % Mod1;
                curh2 = (curh2 * Base + (s[i] - 'a' + 1)) % Mod2;
            }

            if(i >= len - 1)
            {
                if(hashes1[len].count(curh1) == 0 || hashes2[len].count(curh2) == 0) cntsub ++;
                hashes1[len][curh1] ++;
                hashes2[len][curh2] ++;
            }
        }
        Bton1 *= Base;
        Bton1 %= Mod1;
        Bton2 *= Base;
        Bton2 %= Mod2;

    }
    cout << cntsub << " ";
    int pos = 0;

    for(int t = 0; t < q; t ++)
    {
        int type;
        cin >> type;

        if(type == 2)
        {
            long long curh1 = 0, curh2 = 0;
            string curs = "";
            for(int i = pos; i < s.size(); i ++)
            {
                curh1 = (curh1 * Base + (s[i] - 'a' + 1)) % Mod1;
                curh2 = (curh2 * Base + (s[i] - 'a' + 1)) % Mod2;

                hashes1[i - pos +1][curh1] --, hashes2[i - pos + 1][curh2] --;
                if(!hashes1[i - pos + 1][curh1] || !hashes2[i - pos + 1][curh2])
                    cntsub --;
                if(i != pos) curs += s[i];
            }
            s = curs;
        }
        else
        {
            char curc;
            cin >> curc;
            ///s += curc;

            long long curh1 = 0, curh2 = 0;
            long long powb1 = 1LL, powb2 = 1LL;
            for(int i = s.size() - 1; i >= pos; i --)
            {
                ///curh1 = (curh1 + (s[i] - 'a' + 1) * powb1) % Mod1;
                ///curh2 = (curh2 + (s[i] - 'a' + 1) * powb2) % Mod2;
                powb1 *= Base;
                powb1 %= Mod1;
                powb2 *= Base;
                powb2 %= Mod2;

                /**if((!hashes1[s.size() - i].count(curh1) || (hashes1[s.size() - i].count(curh1) && !hashes1[s.size() - i][curh1])) ||
                   (!hashes2[s.size() - i].count(curh2) || (hashes2[s.size() - i].count(curh2) && !hashes2[s.size() - i][curh2])))
                    cntsub ++;
                hashes1[s.size() - i][curh1] ++, hashes2[s.size() - i][curh2] ++;*/
            }
        }
        cout << cntsub << " ";
    }
    cout << endl;

    return 0;
}
