#include<iostream>
#include<utility>
#include<map>
#include<deque>

#define MAX 10001
#define p1 127
#define p2 131
#define MOD1 1000000007
#define MOD2 1000000019

using namespace std;

unsigned long long pow1[MAX];
unsigned long long pow2[MAX];
int n,q;
string s;
deque <char> d;
struct str
{
    long long hash1=0,hash2=0;
    void addFront (char ch, int i)
    {
        hash1 = (unsigned long long) ((ch-'a'+1)*pow1[i]+hash1) % MOD1;
        hash2 = (unsigned long long) ((ch-'a'+1)*pow2[i]+hash2) % MOD2;
    }
    void addBack(char ch)
    {
        hash1 = (unsigned long long) ((hash1*p1)+(ch-'a'+1)) % MOD1;
        hash2 = (unsigned long long) ((hash2*p2)+(ch-'a'+1)) % MOD2;
    }
    void delBack()
    {
        hash1 /= p1;
        hash2 /= p2;
    }
    void delFront(int j,int i)
    {
        hash1 = (unsigned long long) (hash1-(unsigned long long)((s[j]-'a'+1)*pow1[i])%MOD1)%MOD1;
        hash2 = (unsigned long long) (hash2-(unsigned long long)((s[j]-'a'+1)*pow2[i])%MOD2)%MOD2;
    }
    /*bool operator == (const str &o) const
    {
        return (o.hash1 == hash1 && o.hash2 == hash2);
    }
    bool operator < (const str &o) const
    {
        return (o.hash1 < hash1 && o.hash2 < hash2);
    }*/
};


int subStrCount()
{
    int cnt=1;

    for(int k=1; k<n; k++)
    {
        map <pair <long long, long long >, long long> mp;
        str h;
        ///cout<<k<<endl;
        for(int b=0; b<k; b++)
        {
            h.addBack(s[b]);
        }
        if(mp.find(make_pair(h.hash1,h.hash2)) == mp.end())
        {
            mp[make_pair(h.hash1,h.hash2)]=1;
            cnt++;
            ///cout<<k<<" "<<0<<endl;
        }
        ///cout<<"0 "<<h.hash1<<" "<<h.hash2<<endl;
        for(int a=k; a<n; a++)
        {
            h.delFront(a-k,k-1);
            h.addBack(s[a]);
            ///cout<<a-k+1<<" "<<h.hash1<<" "<<h.hash2<<endl;

            if(mp.find(make_pair(h.hash1,h.hash2)) == mp.end())
            {
                mp[make_pair(h.hash1,h.hash2)]=1;
                cnt++;
                ///cout<<k<<" "<<0<<endl;
            }
        }
        /**cout<<"---------"<<cnt<<endl;
        cout<<endl;*/
    }
    return cnt;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin>>s;
    n=s.size();
    ///cout<<n<<endl;
    pow1[0]=1;
    pow2[0]=1;
    str h;
    h.addBack(s[0]);
    d.push_front(s[0]);
    for(int a=1; a<n; a++)
    {
        ///cout<<h.hash1<<" "<<h.hash2<<endl;
        h.addBack(s[a]);
        d.push_front(s[a]);
        pow1[a] = (unsigned long long) (pow1[a-1]*p1) % MOD1;
        pow2[a] = (unsigned long long) (pow2[a-1]*p2) % MOD2;
    }
    cout<<subStrCount()<<endl;

    return 0;
}
/**

abaababa
516513 te 618193
32643 te 34719
*/
