#include<bits/stdc++.h>

#define double long double

using namespace std;
const int nmax=1e2+42,eps=1/1e9;

int n;

struct circle
{
    double x,y,r;
};

circle inp[nmax];

double dist(pair<double,double> a,pair<double,double> b)
{
    return sqrt((a.first-b.first)*(a.first-b.first)+(a.second-b.second)*(a.second-b.second));
}
double score(pair<double,double> a)
{
    double ret=2000;

    for(int i=1;i<=n;i++)
    {
        ret=min(ret,dist(a,{inp[i].x,inp[i].y})-inp[i].r);
    }

    return ret;
}

bool in(pair<double,double> x)
{
    return 0<=x.first&&x.first<=1000&&0<=x.second&&x.second<=1000;
}
bool test(pair<double,double> x,double d)
{
    if(in(x)==0)return 0;

    //cout<<setprecision(18)<<"test "<<x.first<<" "<<x.second<<" "<<score(x)<<" "<<d<<endl;

    return score(x)>=d-eps;
}

pair<double,double> go(double x,double y,double d,double x_dir,double y_dir)
{
    double help=sqrt(x_dir*x_dir+y_dir*y_dir);

    return {x+d*x_dir/help,y+d*y_dir/help};
}
bool eval(double d)
{
    for(int i=1;i<=n;i++)
        for(int j=i+1;j<=n;j++)
        {
            if(test({(inp[i].x+inp[j].x)/2,(inp[i].y+inp[j].y)/2},d))return 1;

            if(dist({inp[i].x,inp[i].y},{inp[j].x,inp[j].y})<=inp[i].r+inp[j].r+2*d)
            {
                double a=inp[i].r+d;

                double b=inp[j].r+d;

                double c=dist({inp[i].x,inp[i].y},{inp[j].x,inp[j].y});

                double p=(a+b+c)/2;

                double S=sqrt(p*(p-a)*(p-b)*(p-c));

                double hc=2*S/c;

                double send=sqrt(a*a-hc*hc);

                double u=inp[j].x-inp[i].x;

                double v=inp[j].y-inp[i].y;

                pair<double,double> mid=go(inp[i].x,inp[i].y,send,u,v);

                pair<double,double> A=go(mid.first,mid.second,hc,v,-u);

                pair<double,double> B=go(mid.first,mid.second,hc,-v,u);

                if(test(A,d))return 1;
                if(test(B,d))return 1;
            }
        }
    return 0;
}
int main()
{
    cin>>n;

    for(int i=1;i<=n;i++)
    {
        cin>>inp[i].x>>inp[i].y>>inp[i].r;
    }

    double ok=0,not_ok=2000;

    for(int t=0;t<75;t++)
    {
        double av=(ok+not_ok)/2;

        if(eval(av))ok=av;
        else not_ok=av;
    }

    cout<<setprecision(18)<<ok<<endl;
    return 0;
}
