#include<bits/stdc++.h>
using namespace std;
const int nmax=1e6+42;

struct info
{
    int id,le,ri;
};

bool cmp(info a,info b)
{
    if(a.le!=b.le)return a.le<b.le;
    if(a.ri!=b.ri)return a.ri<b.ri;
    return a.id<b.id;
}
info help[nmax];

int hsh[20][nmax];

int order[nmax];

int l,r;

string inp;
int n;

void build()
{
    n=inp.size();

    for(int i=0;i<n;i++)
    {
        hsh[0][i]=inp[i]-'a'+1;
    }

    int j;

    for(j=1;(1<<(j-1))<=n;j++)
    {
        for(int i=0;i<n;i++)
        {
            help[i].id=i;
            help[i].le=hsh[j-1][i];

            if(i+(1<<(j-1))<n)help[i].ri=hsh[j-1][i+(1<<(j-1))];
            else help[i].ri=-1;
        }

        sort(help,help+n,cmp);

        //for(int i=0;i<n;i++)cout<<help[i].id<<" "<<help[i].le<<" "<<help[i].ri<<endl;

        int pos=0;

        for(int i=0;i<n;i++)
        {
            hsh[j][help[i].id]=pos;
            if(help[i].le==help[i+1].le&&help[i].ri==help[i+1].ri);
            else pos++;
        }

        //for(int i=0;i<n;i++)cout<<hsh[j][i]<<" ";cout<<endl;

    }

    for(int i=0;i<n;i++)
    {
        order[hsh[j-1][i]]=i;
    }

    //for(int i=0;i<n;i++)cout<<order[i]<<" ";cout<<endl;
}

int LCP(int x,int y)
{
    int ret=0;
    for(int i=19;i>=0;i--)
        if((1<<i)+y<=r+1&&(1<<i)+x<=r+1&&hsh[i][x]==hsh[i][y])
        {
            x=x+(1<<i);
            y=y+(1<<i);
            ret=ret+(1<<i);
        }
    return ret;
}
long long ask()
{
    int prv=-1;

    long long ret=1LL*(r-l+1)*(r-l+2)/2;

    //cout<<"! "<<r-l+1<<" "<<ret<<endl;

    for(int i=0;i<n;i++)
    {
        if(l<=order[i]&&order[i]<=r)
        {
            if(prv!=-1)ret=ret-LCP(prv,order[i]);
            prv=order[i];
        }
    }

    return ret;
}

int type[nmax];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin>>inp;

    l=0,r=inp.size()-1;

    int q;
    cin>>q;

    for(int i=1;i<=q;i++)
    {
        cin>>type[i];

        if(type[i]==1)
        {
            char c;
            cin>>c;

            inp.push_back(c);
        }
    }

    build();

    cout<<ask();

    for(int i=1;i<=q;i++)
    {
        if(type[i]==1)r++;
        else l++;

        cout<<" "<<ask();
    }

    cout<<endl;
    return 0;
}

