#include<bits/stdc++.h>
using namespace std;
const int nmax=1e6+42;

struct info
{
    int id,le,ri;
};

bool cmp(info a,info b)
{
    if(a.le!=b.le)return a.le<b.le;
    if(a.ri!=b.ri)return a.ri<b.ri;
    return a.id<b.id;
}
info help[nmax],other[nmax];

int hsh[20][nmax];

int order[nmax];

int l,r;

string inp;
int n;

int seen[nmax],pref[nmax];

void radix_1()
{
    for(int i=0;i<n+5;i++)seen[i]=0;

    for(int i=0;i<n;i++)
    {
        seen[help[i].ri]++;
    }

    pref[0]=seen[0];

    for(int i=1;i<n+5;i++)pref[i]=pref[i-1]+seen[i];

    seen[0]=0;

    for(int i=1;i<n+5;i++)
    {
        seen[i]=pref[i-1];
    }

    for(int i=0;i<n;i++)
    {
        other[seen[help[i].ri]]=help[i];
        seen[help[i].ri]++;
    }

    for(int i=0;i<n;i++)help[i]=other[i];
}

void radix_0()
{
    for(int i=0;i<n+5;i++)seen[i]=0;

    for(int i=0;i<n;i++)
    {
        seen[help[i].le]++;
    }

    pref[0]=seen[0];

    for(int i=1;i<n+5;i++)pref[i]=pref[i-1]+seen[i];

    seen[0]=0;

    for(int i=1;i<n+5;i++)
    {
        seen[i]=pref[i-1];
        //cout<<i<<" -> "<<seen[i]<<endl;
    }

    for(int i=0;i<n;i++)
    {
        //cout<<"into "<<seen[help[i].le]<<endl;

        other[seen[help[i].le]]=help[i];
        seen[help[i].le]++;
    }

    for(int i=0;i<n;i++)help[i]=other[i];
}


void build()
{
    n=inp.size();

    l=0;

    r=n-1;

    set<char> c={};

    for(int i=0;i<n;i++)c.insert(inp[i]);

    map<char,int> w={};
    int pos=0;

    for(auto k:c)
    {
        w[k]=pos;
        pos++;
    }

    for(int i=0;i<n;i++)
    {
        hsh[0][i]=w[inp[i]];
    }

    int j;

    for(j=1;(1<<(j-1))<=n;j++)
    {
        for(int i=0;i<n;i++)
        {
            help[i].id=i;
            help[i].le=hsh[j-1][i];

            if(i+(1<<(j-1))<n)help[i].ri=hsh[j-1][i+(1<<(j-1))]+1;
            else help[i].ri=-1+1;
        }

        radix_1();
        /*
        for(int i=0;i<n;i++)cout<<help[i].id<<" "<<help[i].le<<" "<<help[i].ri<<endl;
        cout<<"---"<<endl;
        */

        radix_0();

        //for(int i=0;i<n;i++)cout<<help[i].id<<" "<<help[i].le<<" "<<help[i].ri<<endl;

        int pos=0;

        for(int i=0;i<n;i++)
        {
            //cout<<help[i].id<<" -> "<<pos<<endl;

            hsh[j][help[i].id]=pos;
            if(help[i].le==help[i+1].le&&help[i].ri==help[i+1].ri);
            else pos++;
        }

        //for(int i=0;i<n;i++)cout<<hsh[j][i]<<" ";cout<<endl;

        //cout<<"---"<<endl;
    }

    for(int i=0;i<n;i++)
    {
        order[hsh[j-1][i]]=i;
    }
}

int LCP(int x,int y)
{
    int ret=0;
    for(int i=19;i>=0;i--)
        if((1<<i)+y<=r+1&&(1<<i)+x<=r+1&&hsh[i][x]==hsh[i][y])
        {
            x=x+(1<<i);
            y=y+(1<<i);
            ret=ret+(1<<i);
        }
    return ret;
}

long long ask()
{
    build();

    int prv=-1;

    long long ret=1LL*(r-l+1)*(r-l+2)/2;

    //cout<<"! "<<r-l+1<<" "<<ret<<endl;

    for(int i=0;i<n;i++)
    {
        if(l<=order[i]&&order[i]<=r)
        {
            if(prv!=-1)ret=ret-LCP(prv,order[i]);
            prv=order[i];
        }
    }

    return ret;
}

int type[nmax];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    cin>>inp;

    l=0,r=inp.size()-1;

    if(inp.size()>5000)
    {
        //only cut
        long long mem=ask();

        cout<<mem<<" ";

        set< pair<int,int> > ordered={};
        for(int i=0;i<n;i++)
            ordered.insert({i,order[i]});

        map<int,int> where={};
        for(int i=0;i<n;i++)
            where[order[i]]=i;

        int n_=n;

        int q;

        cin>>q;

        for(int i=0;i<q;i++)
        {
            int type;
            cin>>type;

            mem=mem-n_;

            n_--;

            l++;

            set< pair<int,int> >::iterator it=ordered.lower_bound({where[i],i});

            pair<int,int> prv_help={-1,-1},nxt_help={-1,-1};

            if(it!=ordered.begin())
            {
                it--;

                prv_help=*it;
                mem=mem+LCP(where[i],prv_help.second);
            }

            it=ordered.lower_bound({where[i],i});

            it++;

            if(it!=ordered.end())
            {
                nxt_help=*it;
                mem=mem+LCP(where[i],nxt_help.second);
            }

            if(prv_help.first!=-1&&nxt_help.first!=-1)mem=mem-LCP(prv_help.second,nxt_help.second);

            ordered.erase({where[i],i});

            cout<<" "<<mem;
        }

        cout<<endl;
        return 0;
    }
    int q;
    cin>>q;

    cout<<ask();

    for(int i=1;i<=q;i++)
    {
        cin>>type[i];

        if(type[i]==1)
        {
            char c;
            cin>>c;

            inp.push_back(c);
        }
        else inp.erase(inp.begin(),inp.begin()+1);

        cout<<" "<<ask();
    }
    cout<<endl;


    return 0;
}

