#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <map>
#define pb push_back
#define eb push_back
#define all(x) x.begin,x.end()
#define sz(x) ((int)x.size())
#define f first
#define s second

#pragma GCC optimize ("O3")
#pragma GCC target ("sse2")
#pragma GCC optimize ("unroll-loops")

using namespace std;

const int MAXN = 2e5;
int n, s, t;
pair<int, int> p[MAXN];
bool usrn[MAXN];
bool usl[MAXN];
bool usm[MAXN];
set<int> a[3], b[3];
int mxfl = 0;

void input() {
    int l, m;
    cin>>n>>s>>t;
    for (int i=0; i<n; i++) {
        cin>>l>>m;
        p[i] = {l, m};
    }
}

void output() {
    cout<<mxfl<<' ';
    for (int i=0; i<3; i++) {
        cout<<sz(a[i])<<' '<<sz(b[i])<<' ';
    }
    cout<<endl;
    for (int i=0; i<3; i++) {
        for (auto t : a[i]) {
            cout<<t<<' ';
        }
        cout<<'\n';
        for (auto t : b[i]) {
            cout<<t<<' ';
        }
        cout<<'\n';
    }
}

void recursion(int pos, int cnt) {
    if (pos == n) {
        if (mxfl < cnt) {
            for (int i=1; i<=n; i++) {
                a[0].insert(i);
                b[0].insert(i);
            }
            for (int i=1; i<=s; i++) {
                a[1].insert(i);
                b[1].insert(i);
            }
            for (int i=1; i<=t; i++) {
                a[2].insert(i);
                b[2].insert(i);
            }
            mxfl = cnt;
        }
        if (mxfl == cnt) {
            for (int i=1; i<=n; i++) {
                if (usrn[i]) {
                    b[0].erase(i);
                } else {
                    a[0].erase(i);
                }
            }
            for (int i=1; i<=s; i++) {
                if (usl[i]) {
                    b[1].erase(i);
                } else {
                    a[1].erase(i);
                }
            }
            for (int i=1; i<=t; i++) {
                if (usm[i]) {
                    b[2].erase(i);
                } else {
                    a[2].erase(i);
                }
            }
        }
        return;
    }
    
    for (int i=pos; i<n; i++) {
        if (!usl[p[i].f] && !usm[p[i].s]) {
            usl[p[i].f] = 1;
            usm[p[i].s] = 1;
            usrn[i+1] = 1;
            recursion(pos+1, cnt+1);
            usl[p[i].f] = 0;
            usm[p[i].s] = 0;
            usrn[i+1] = 0;
        }
    }
    recursion(n, cnt);
}

void solve() {
    recursion(0, 0);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}
/*
6 4 5
1 1
2 1
3 2
3 3
3 4
4 4

4 3 2
1 1
2 1
2 2
3 2

4 2 3
1 1
1 2
2 2
2 3
*/