#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 + 5;

struct suf
{
	map <char, int> next;
	int link, len;
};

int n;
char str[MAXN];
suf s[MAXN];
int sz, last;

void init()
{
	s[0].link = -1;
	s[0].len = 0;
	sz = 1; last = 0;
}

void add_char(char c)
{
	int cur = sz++;
	s[cur].len  = s[last].len + 1;
	int p = last;
	while(p != -1 && !s[p].next.count(c))
	{
		s[p].next[c] = cur;
		p = s[p].link;
	}
	if(p == -1)
	{
		s[cur].link = 0;
	}
	else
	{
		int q = s[p].next[c];
		if(s[p].len + 1 == s[q].len)
		{
			s[cur].link = q;
		}
		else
		{
			int clone = sz++;
			s[clone].len = s[p].len + 1;
			s[clone].next = s[q].next;
			s[clone].link = s[q].link;
			while(p != -1 && s[p].next[c] == q)
			{
				s[p].next[c] = clone;
				p = s[p].link;
			}
			s[cur].link = s[q].link = clone;
		}
	}
	last = cur;
}

void build()
{
	init();
	for(int i = 0; i < n; i++)
	{
		add_char(str[i]);
	}
}

long long T[MAXN];

long long rec(int v)
{
	if(T[v])
	{
		return T[v];
	}
	long long answer = 1;
	//cout << v << "\n";
	for(auto x : s[v].next)
	{
		answer += rec(x.second);
	}
	return T[v] = answer;
}

void sol()
{
	//cout << sz << "\n";
	cout << rec(0) - 1 << "\n";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> str;
	n = strlen(str);
	build();
	sol();
	int q;
	cin >> q;

	return 0;
}
