#include <bits/stdc++.h>

using namespace std;

const int MAXN = 4e7 + 5;

struct suf
{
	map <char, int> next;
	int link, len;
};

int n;
char str[MAXN];
suf s[MAXN];
int sz, last;

void init()
{
	//s[sz].next.clear();
	s[sz].link = -1;
	s[sz].len = 0;
	sz++; last = sz;
}

void add_char(int c)
{
	c -= 'a';
	int cur = sz++;
	//s[cur].next.clear();
	s[cur].len  = s[last].len + 1;
	int p = last;
	while(p != -1 && !s[p].next.count(c))
	{
		s[p].next[c] = cur;
		p = s[p].link;
	}
	if(p == -1)
	{
		s[cur].link = 0;
	}
	else
	{
		int q = s[p].next[c];
		if(s[p].len + 1 == s[q].len)
		{
			s[cur].link = q;
		}
		else
		{
			int clone = sz++;
			s[clone].len = s[p].len + 1;
			s[clone].next = s[q].next;
			s[clone].link = s[q].link;
			while(p != -1 && s[p].next[c] == q)
			{
				s[p].next[c] = clone;
				p = s[p].link;
			}
			s[cur].link = s[q].link = clone;
		}
	}
	last = cur;
}

int st, ed;

void build()
{
	init();
	for(int i = st; i < ed; i++)
	{
		add_char(str[i]);
	}
}

long long T[MAXN];

long long rec(int v)
{
	if(T[v] != -1)
	{
		return T[v];
	}
	long long answer = 1;
	//for(int i = 0; i < 26; i++)
	for(auto x : s[v].next)
	{
		//int to = s[v].next[i];
		//if(to)
		answer += rec(x.second);
	}
	return T[v] = answer;
}

void sol()
{
	//cout << sz << "\n";
	
	cout << rec(0) - 1 << " ";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> str;
	n = strlen(str);
	st = 0, ed = n;
	build();
	for(int i = 0; i < MAXN; i++)
	{
		T[i] = -1;
	}
	sol();
	int q;
	cin >> q;
	int v;
	char C;
	for(int i = 0; i < q; i++)
	{
		cin >> v;
		if(v == 1)
		{
			cin >> C;
			str[ed] = C;
			ed++;
		}
		else
		{
			st++;
		}
		build();
		sol();
	}
	cout << "\n";

	return 0;
}
