#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 5;

struct suf
{
	map <char, int> next;
	int link, len;
};

int n;
char str[2 * MAXN];
suf s[2 * MAXN];
int sz, last;
int dep[MAXN];

void init()
{
	s[0].next.clear();
	s[0].link = -1;
	s[0].len = 0;
	dep[0] = 0;
	sz = 1; last = 0;
}

void add_char(int c)
{
	c -= 'a';
	int cur = sz++;
	s[cur].next.clear();
	s[cur].len = s[last].len + 1;
	dep[cur] = dep[last] + 1;
	int p = last;
	while(p != -1 && !s[p].next.count(c))
	{
		s[p].next[c] = cur;
		p = s[p].link;
	}
	if(p == -1)
	{
		s[cur].link = 0;
	}
	else
	{
		int q = s[p].next[c];
		if(s[p].len + 1 == s[q].len)
		{
			s[cur].link = q;
		}
		else
		{
			int clone = sz++;
			dep[clone] = dep[q];
			s[clone].len = s[p].len + 1;
			s[clone].next = s[q].next;
			s[clone].link = s[q].link;
			while(p != -1 && s[p].next[c] == q)
			{
				s[p].next[c] = clone;
				p = s[p].link;
			}
			s[cur].link = s[q].link = clone;
		}
	}
	last = cur;
}

int st, ed;

void build()
{
	init();
	for(int i = st; i < ed; i++)
	{
		add_char(str[i]);
	}
}

long long T[MAXN];

long long dp()
{
	vector <pair<int, int>> ve;
	for(int i = 0; i < sz; i++)
	{
		ve.push_back({dep[i], i});
	}
	sort(ve.begin(), ve.end());

	for(int i = sz - 1; i >= 0; i--)
	{
		int temp = ve[i].second;
		T[temp] = 1;
		for(auto x : s[temp].next)
		{
			T[temp] += T[x.second];
		}
	}
	return T[0] - 1;
}

void sol()
{
	//cout << sz << "\n";
	
	cout << dp() << " ";
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> str;
	n = strlen(str);
	st = 0, ed = n;
	build();
	sol();
	int q;
	cin >> q;
	int v;
	char C;
	for(int i = 0; i < q; i++)
	{
		cin >> v;
		if(v == 1)
		{
			cin >> C;
			str[ed] = C;
			ed++;
		}
		else
		{
			st++;
		}
		build();
		sol();
	}
	cout << "\n";

	return 0;
}
