#include<iostream>
using namespace std;

const int maxn = 20;
const int maxs = 10;
int n, s, t;

int st[maxn][2];

int num_cases;
int st_used[maxn];
int s_used[maxs];
int t_used[maxs];

int check(long long mask, bool log)
{
    int s[maxs] = {}, t[maxs] = {};
    for(int i = 0; i < maxs; i ++)  s[i] = t[i] = 0;
    int cnt = 0;
    for(int i = 0; i < n; i ++)
    {
        if(((1<<i) & mask) != 0)
        {
            s[st[i][0]] ++;
            t[st[i][1]] ++;
            cnt ++;
        }
    }


    for(int i = 0; i < maxs; i ++)
    {
        if(s[i] > 1 || t[i] > 1)    return 0;
    }
    if(log)
    {
        num_cases ++;
        for(int i = 0; i < maxs; i ++)
        {
            s_used[i] += s[i];
            t_used[i] += t[i];
        }
        for(int i = 0; i < n; i ++)
        {
            if(((1<<i) & mask) != 0)
            {
                st_used[i] ++;
            }
        }
    }
    return cnt;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> s >> t;
    for(int i = 0; i < n; i ++)
    {
        cin >> st[i][0] >> st[i][1];
        st[i][0] --;
        st[i][1] --;
    }

    int mx = 0;
    for(int i = 0; i < (1<<n); i ++)
    {
        mx = max(mx, check(i, false));
    }
    for(int i = 0; i < (1<<n); i ++)
    {
        if(mx == check(i, false))
        {
            check(i, true);
        }
    }

    int an = 0, bn = 0, al = 0, bl = 0, am = 0, bm = 0;

    for(int i = 0; i < n; i ++)
    {
        if(st_used[i] == num_cases) an ++;
        if(st_used[i] == 0) bn ++;
    }
    for(int i = 0; i < s; i ++)
    {
        if(s_used[i] == num_cases) al ++;
        if(s_used[i] == 0) bl ++;
    }
    for(int i = 0; i < t; i ++)
    {
        if(t_used[i] == num_cases) am ++;
        if(t_used[i] == 0) bm ++;
    }

    cout << mx << " " << an << " " << bn << " "  << al << " " << bl << " "  << am << " " << bm << endl;

    for(int i = 0; i < n; i ++)
    {
        if(st_used[i] == num_cases) cout << i + 1 << " ";
    }
    cout << endl;
    for(int i = 0; i < n; i ++)
    {
        if(st_used[i] == 0) cout << i + 1 << " ";
    }
    cout << endl;
    for(int i = 0; i < s; i ++)
    {
        if(s_used[i] == num_cases) cout << i + 1 << " ";
    }
    cout << endl;
    for(int i = 0; i < s; i ++)
    {
        if(s_used[i] == 0) cout << i + 1 << " ";
    }
    cout << endl;
    for(int i = 0; i < t; i ++)
    {
        if(t_used[i] == num_cases) cout << i + 1 << " ";
    }
    cout << endl;
    for(int i = 0; i < t; i ++)
    {
        if(t_used[i] == 0) cout << i + 1 << " ";
    }
    cout << endl;
}
