#include <iostream>
#include <vector>
#include <tuple>
#include <math.h>

using namespace std;

int main()
{
    int n;
    cin >> n;

    vector<tuple<double, double, double> > circles;
    for(int i = 0; i < n; i++){
        double x, y, r;

        cin >> x >> y >> r;

        circles.push_back(tuple<double, double, double>(x, y, r));
    }

    if(n == 2){
        auto [x1, y1, r1] = circles.at(0);
        auto [x2, y2, r2] = circles.at(1);

        auto dist = sqrt(pow(x2 - x1, 2) + pow(y2 - y1, 2));

        double fa, fb;
        fa = (y1 - y2) / (x1 - x2);
        fb = y1 - fa*x1;
        double point1x = (abs(x1 - x2)*r1)/dist;
        double point1y = fa*(point1x) + fb;
        double point2x = (abs(x1 - x2)*(dist-r2))/dist;
        double point2y = fa*(point2x) + fb;
        double midx = abs(point1x - point2x) / 2;
        double midr = (dist - r1 - r2)/2;
        cout << midr << endl;
    }
}


