#include<bits/stdc++.h>
using namespace std;
struct edge
{
    int f,to;
    long long cap,flow;
    edge(int ss,int ee,long long cp):f(ss),to(ee),cap(cp),flow(0){}
};
vector<vector<int>> adj;
int n,m=0;
int s,t;
vector<edge> edges;
queue<int> q;
vector<long long> ptr,level;
void add_edge(int f,int t,int cp)
{
    edges.emplace_back(f,t,cp);
    edges.emplace_back(t,f,0);
    adj[f].push_back(m++);
    adj[t].push_back(m++);
}
long long MAXFLOW=2;
bool bfs()
{
    fill(level.begin(),level.end(),-1);
    fill(ptr.begin(),ptr.end(),0);
    q.push(s);
    level[s]=0;
    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        for(int next = 0;next < adj[curr].size();next++)
        {
            int edge_id = adj[curr][next];
            if(level[edges[edge_id].to]!=-1 or edges[edge_id].cap-edges[edge_id].flow<1)
                continue;
            level[edges[edge_id].to] = level[curr] + 1;
            q.push(edges[edge_id].to);
        }
    }
    return level[t]!=-1;
}
long long dfs(int curr,long long passed = MAXFLOW)
{
    if(passed==0)
        return 0;
    if(curr==t)
        return passed;
    for(;ptr[curr] < adj[curr].size();ptr[curr]++)
    {
        int edge_id = adj[curr][ptr[curr]];
        int to = edges[edge_id].to;
        if(level[curr] + 1 != level[to] or edges[edge_id].cap-edges[edge_id].flow <1)
            continue;
        long long pushed = dfs(to,min(passed,edges[edge_id].cap-edges[edge_id].flow));
        edges[edge_id].flow += pushed;
        edges[edge_id^1].flow -=pushed;
        return pushed;
    }
    return 0;
}
long long flow()
{
    long long res=0;
    while(bfs())
        while(long long f = dfs(s))
            res += f;
    return res;
}
long long tellMeFlowIfEdgeIs0(int id)
{
    int old = edges[id].cap;
    edges[id].cap = 0;
    for(edge& e:edges)
    {
        e.flow=0;
    }
    long long fl = flow();
    edges[id].cap = old;
    return fl;
}
int main()
{

}
