#include <iostream>
#include <unordered_map>
#include <bitset>
#include <cstring> // memset
using namespace std;

typedef unsigned long long ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

const ull MODMASK = 0x3ffffff;
//const ull MODMASK = 1e9 + 7;
//bool map[MODMASK];
std::bitset<MODMASK> map;

ull queryWithLen(int len) {
	ull ans = 0;
	//std::unordered_map<ull, bool> map;

	ull hash = 0;
	const ull BASE = 27;
	ull maxMul = 1;
	ull prevMaxMul = 1;
	for(int i = from;i < len+from;i ++) {
		hash *= BASE;
		prevMaxMul = maxMul;
		maxMul *= BASE;
		hash += inp[i];
		//hash %= MODMASK;
	}
	maxMul = prevMaxMul;

	//ans += !map[hash];
	//map[hash] = true;
	
	ans += !map[hash & MODMASK];
	map[hash & MODMASK] = true;

	//cout << inp.substr(0, len) << ' ' << hash << endl;

	//cout << "HERE " << len << ' ' << maxMul << endl;
	const int S = inp.size();
	for(int i = from+len;i < S;i ++) {
		hash -= inp[i-len] * maxMul;
		hash *= BASE;
		hash += inp[i];

		//hash %= MODMASK;
		//ans += !map[hash];
		//map[hash] = true;

		ans += !map[hash & MODMASK];
		map[hash & MODMASK] = true;

		//cout << inp.substr(i-len, len) << ' ' << hash << endl;
	}

	//cout << "END " << len << ' ' << ans << endl;

	return ans;
}

ull query() {
	if(inp.size() == from) return 0;

	ull ans = 0;
	for(int i = 1;i < inp.size()-from;i ++) {
		ans += queryWithLen(i);
		//memset(map, 0, MODMASK);
		map.reset();
	}
	return ans + 1; // +1 for len=N
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	cin >> inp;

	int Q; cin >> Q;

	cout << query() << ' ';

	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			cout << query() << ' ';
		} else {
			from ++;
			cout << query() << ' ';
		}
		//cout << inp << endl;
	}
	return 0;
}
