#pragma GCC optimize "Ofast"
#include <iostream>
#include <unordered_map>
#include <bitset>
#include <cstring> // memset
using namespace std;

//typedef unsigned long long ull;
typedef unsigned int ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

const ull MOD = 1e9 + 7;
const ull BASE = 27;
const int MAX_NPQ = 5e3 + 250;
ull mem[MAX_NPQ][MAX_NPQ];
std::unordered_map<ull, unsigned int> map[MAX_NPQ];
ull ans = 0;

/*
ull _hash(int pos, int len) {
	ull hash = 0;
	for(int i = pos+from;i < pos+from+len;i ++) {
		hash *= BASE;
		hash += inp[i];
		//hash %= MODMASK;
	}
	return hash;
}

void queryWithLen(int len) {
	ull hash = _hash(0, len);
	ull maxMul = 1;
	for(int i = 0;i < len-1;i ++) maxMul *= BASE;

	ans += map[len][hash] == 0;
	map[len][hash] ++;
	
	//ans += !map[hash & MODMASK];
	//map[hash & MODMASK] = true;

	//cout << inp.substr(0, len) << ' ' << hash << endl;

	//cout << "HERE " << len << ' ' << maxMul << endl;
	const int S = inp.size();
	for(int i = from+len;i < S;i ++) {
		hash -= inp[i-len] * maxMul;
		hash *= BASE;
		hash += inp[i];

		//hash %= MODMASK;
		ans += map[len][hash] == 0;
		map[len][hash] ++;

		//ans += !map[hash & MODMASK];
		//map[hash & MODMASK] = true;

		//cout << inp.substr(i-len, len) << ' ' << hash << endl;
	}

	//cout << "END " << len << ' ' << ans << endl;
}

void query() {
	ans = 0;
	for(int i = 1;i < inp.size()-from+1;i ++) queryWithLen(i);
	//if(inp.size()-from != 0) ans ++; // +1 for len=N
}
*/

void modOp1() {
	//cout << "=========== OP 1" << endl;
	for(int len = 1;len < inp.size()-from+1;len ++) {
		ull hash = mem[len-1][inp.size()-len];
		hash *= BASE;
		hash += inp[inp.size()-1];
		hash %= MOD;
		mem[len][inp.size()-len] = hash;

		//cout << "adding " << inp.substr(inp.size()-len, len) << ' ' << hash << endl;
		//cout << map[len][hash] << endl;
		if(map[len][hash] == 0) ans ++;
		map[len][hash] ++;
	}
}

void modOp2() {
	//cout << "===========" << endl;
	for(int len = 1;len < inp.size()-from+2;len ++) {
		ull hash = mem[len][from-1];
		//cout << "removing " << inp.substr(from-1, len) << ' ' << hash << endl;
		map[len][hash] --;
		//cout << map[len][hash] << endl;
		if(map[len][hash] == 0) ans --;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string spam;
	cin >> spam;
	for(int i = 0;i < spam.size();i ++) {
		inp += spam[i];
		modOp1();
		//cout << "HERE " << i << endl;
		//if(i >= 2) return 0;
	}

	//query();
	cout << ans << ' ';
	//cout << "starting Qs " << endl;

	int Q; cin >> Q;
	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			modOp1();
			cout << ans << ' ';
		} else {
			from ++;
			modOp2();
			cout << ans << ' ';
			/*
			if(from > 100) {
				inp = inp.substr(from, inp.size()-from);
				from = 0;
			}
			*/
			//break;
		}
		//if(i > 2) return 0;
		//cout << inp << endl;
	}
	return 0;
}
