#pragma GCC optimize "Ofast"
#include <iostream>
#include <unordered_map>
#include <map>
#include <bitset>
using namespace std;

//typedef unsigned long long ull;
typedef unsigned int ull;

// TODO vector of normalized ints
std::string inp;
int from = 0;

struct S {
	int first;
	int second;
};
bool operator==(const S& lhs, const S& rhs) {
	return lhs.first == rhs.first&& lhs.second== rhs.second;
}

namespace std
{
	template<> struct hash<S>
	{
		size_t operator()(S const& s) const noexcept
		{
			return s.first ^ (s.second << 15);
			//std::size_t h1 = std::hash<size_t>{}(s.first);
			//std::size_t h2 = std::hash<size_t>{}(s.second);
			//return h1 ^ (h2 << 1);
		}
	};
}


//const ull MOD = 1e9 + 7;
const ull BASE = 127;
const int MAX_NPQ = 5e3 + 204;
//ull mem[MAX_NPQ][MAX_NPQ];
std::unordered_map<S, ull> mem;
std::unordered_map<ull, unsigned int> mmap[MAX_NPQ];
unsigned long long ans = 0;

void modOp1() {
	for(int len = 1;len < inp.size()-from+1;len ++) {
		const S asd = {int(inp.size())-len, len-1};
		ull hash = mem[asd];
		hash *= BASE;
		hash += inp[inp.size()-1];
		const S bsd = {int(inp.size())-len, len};
		mem[bsd] = hash;

		if(mmap[len][hash] == 0) ans ++;
		mmap[len][hash] ++;
	}
}

void modOp2() {
	for(int len = 1;len < inp.size()-from+2;len ++) {
		const S asd = {from-1, len};
		ull hash = mem[asd];
		mmap[len][hash] --;
		if(mmap[len][hash] == 0) ans --;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string spam;
	cin >> spam;
	for(int i = 0;i < spam.size();i ++) {
		inp += spam[i];
		modOp1();
		//if(i%100==0) cerr << i << endl;
	}

	cout << ans << ' ';

	int Q; cin >> Q;
	for(int i = 0;i < Q;i ++) {
		int op; cin >> op;

		if(op == 1) {
			char val; cin >> val;
			inp += val;
			modOp1();
			cout << ans << ' ';
		} else {
			from ++;
			modOp2();
			cout << ans << ' ';
		}
	}
	return 0;
}
