#include<bits/stdc++.h>
using namespace std;
int const maxn = 1e5;

map<long long,bool>mp;
long long base = 29;
long long mod = 1e9+7;
long long p[maxn];

void pow()
{
    int i;
    p[0] = 1;

    for(i=1;i<maxn;i++)
        p[i] = (p[i-1]*base)%mod;
}

int check(int x)
{
    if(!mp[x])
    {
        mp[x] = true;
        return 1;
    }

    return 0;
}

long long h[maxn];
void hashing(string s)
{
    int i,sz=s.size();
    h[0] = 0;
    for(i=1;i<=sz;i++)
    {
        h[i] = (h[i-1] * base + s[i-1] - 'a' + 1)%mod;
    }
}

void solve(string s)
{
    int ans = 0;
    int i,sz=s.size(),j;

    hashing(s);
    pow();

    for(i=1;i<=sz;i++)
    {
        int t;

        for(j=i;j<=sz;j++)
        {
            t = (h[j] - h[j-i]*p[i])%mod;
            t = (t+mod)%mod;
            //cout<<h[j]<<" "<<h[j-i]<<" "<<p[i]<<" ";
            ans += check(t);
            //cout<<t<<"\n";
        }
        //cout<<endl;
    }

    cout<<ans<<endl;
}

int main()
{
    string s;
    int q,i,t,x;

    cin>>s;
    solve(s);

    cin>>q;
    for(i=0;i<q;i++)
    {
        cin>>t;

        if(t == 1)
        {
            cin>>x;
        }
        else
        {

        }
    }

    return 0;
}
