#include<bits/stdc++.h>
using namespace std;
int const maxn = 5*1e3;

map<long long,bool>mp;
long long base = 29;
long long mod = 1e9+7;
long long p[maxn];

void pow()
{
    int i;
    p[0] = 1;

    for(i=1;i<maxn;i++)
        p[i] = (p[i-1]*base)%mod;
}

int check(long long x)
{
    if(!mp[x])
    {
        mp[x] = true;
        return 1;
    }

    return 0;
}

long long h[maxn];
void hashing(string s)
{
    int i,sz=s.size();
    h[0] = 0;
    for(i=1;i<=sz;i++)
    {
        h[i] = (h[i-1] * base + s[i-1] - 'a' + 1)%mod;
    }
}
vector<long long>v;

void solve(string s)
{
    long long ans = 0;
    int i,sz=s.size(),j;
    mp.clear();
    hashing(s);

    for(i=1;i<=sz;i++)
    {
        int t;

        for(j=i;j<=sz;j++)
        {
            t = (h[j] - h[j-i]*p[i])%mod;
            t = (t+mod)%mod;
            //cout<<h[j]<<" "<<h[j-i]<<" "<<p[i]<<" ";
            ans += check(t);
            //cout<<t<<"\n";
        }
        //cout<<endl;
    }

    v.push_back(ans);
}

int main()
{
    string s;
    int q,i,t;
    char c;
    pow();
    cin>>s;
    solve(s);

    cin>>q;
    for(i=0;i<q;i++)
    {
        cin>>t;

        if(t == 1)
        {
            cin>>c;
            s = s + c;
        }
        else
        {
            s = s.erase(0,1);
        }
        //cout<<s<<endl;
        solve(s);
    }

    for(i=0;i<v.size();i++)
        cout<<v[i]<<" ";


    return 0;
}
