#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define pii pair <int, int>
#define endl '\n'
#pragma gcc optimize ("O3")
#pragma gcc target ("sse4")
using namespace std;
const int MC = 2;
const int MOD[2] = {(int)1e9 + 7, (int)1e9 + 9};
const int P[2] = {31, 37};
const int N = 5e3 + 5;

int val(char ch)
{
    return 1 + (int)(ch - 'a');
}

string int_to_s(int x)
{
    string res = "";
    while(x)
    {
        res.pb((char)(x % 10 + '0'));
        x /= 10;
    }
    if(res.size() == 0)
        res = "0";
    reverse(res.begin(), res.end());
    return res;
}

string vec_to_s(vector <int> &v)
{
    string res = "";
    for(int x: v)
    {
        res += int_to_s(x);
        res += " ";
    }
    return res;
}

int head, tail;
char q[N];

ll ans;
unordered_map <string, int> cnt;
void add(char ch)
{
    q[tail++] = ch;

    vector <int> h;
    vector <int> cp;
    for(int i = 0; i < MC; i++)
    {
        h.pb(0);
        cp.pb(1);
    }
    for(int i = tail - 1; i >= head; i--)
    {
        for(int j = 0; j < MC; j++)
        {
            h[j] = (1LL * h[j] + 1LL * cp[j] * val(q[i])) % MOD[j];
            cp[j] = (1LL * cp[j] * P[j]) % MOD[j];
        }

        string t = vec_to_s(h);

        cnt[t]++;
        if(cnt[t] == 1)
            ans++;
    }
}

void rmv()
{
    vector <int> h;
    for(int i = 0; i < MC; i++)
        h.pb(0);

    for(int i = head; i < tail; i++)
    {
        for(int j = 0; j < MC; j++)
            h[j] = (1LL * h[j] * P[j] + val(q[i])) % MOD[j];

        string t = vec_to_s(h);
        cnt[t]--;
        if(cnt[t] == 0)
            ans--;
    }
    head++;
}
int main()
{
    cin.tie(NULL); cout.tie(NULL);
    ios_base::sync_with_stdio(false);

    //cnt.max_bucket_count(500000);
    cnt.max_load_factor(1.0);

    string s;
    cin >> s;
    for(int i = 0; i < (int)s.size(); i++)
        add(s[i]);

    cout << ans << ' ';

    int Q;
    cin >> Q;
    while(Q--)
    {
        int type;
        cin >> type;
        if(type == 2)
        {
            rmv();
        }
        else
        {
            char ch;
            cin >> ch;
            add(ch);
        }

        cout << ans << ' ';
    }
    cout << endl;

    return 0;
}

/*

abaababa
6
2
1 b
1 b
2
2
2

*/
