#include <bits/stdc++.h>
using namespace std;

const int N=105;

long double x[N],y[N],r[N];
int n;

long double Distance(long double x1,long double y1,long double x2,long double y2)
{
 return sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
}

long double GetMaxRadius(long double p,long double q)
{
 long double dist,mn;
 int i;

 mn=10000;
  for(i=1;i<=n;i++)
  {
   dist=Distance(p,q,x[i],y[i]);
   dist-=r[i];

    if(dist<0)
     return -1;

   mn=min(mn,dist);
  }

 return mn;
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int i;
long double mx,current,p,q,bestp,bestq,step;

cin>>n;

 for(i=1;i<=n;i++)
  cin>>x[i]>>y[i]>>r[i];

mx=-1;
 for(p=0;p<=1000;p++)
  for(q=0;q<=1000;q++)
  {
   current=GetMaxRadius(p,q);

    if(current>mx)
    {
     mx=current;
     bestp=p;
     bestq=q;
    }
  }

step=0.001;
 for(p=bestp-1;p<=bestp+1;p+=step)
  for(q=bestq-1;q<=bestq+1;q+=step)
  {
   current=GetMaxRadius(p,q);
   mx=max(mx,current);
  }

cout<<fixed<<setprecision(12)<<mx<<"\n";

return 0;
}
