#include <bits/stdc++.h>
using namespace std;

const int N=105;

long double x[N],y[N],r[N];
int n;

long double Max(long double p,long double q)
{
  if(p>q)
   return p;

 return q;
}

long double Min(long double p,long double q)
{
  if(p<q)
   return p;

 return q;
}

long double Distance(long double x1,long double y1,long double x2,long double y2)
{
 return sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
}

long double GetMaxRadius(long double p,long double q)
{
 long double dist,mn;
 int i;

 mn=10000;
  for(i=1;i<=n;i++)
  {
   dist=Distance(p,q,x[i],y[i]);
   dist-=r[i];

    if(dist<0)
     return -1;

   mn=min(mn,dist);
  }

 return mn;
}

int main()
{

ios::sync_with_stdio(false);
cin.tie(nullptr);

int i,iter;
long double mx,current,p,q,bestp,bestq,step,lowp,highp,lowq,highq;

cin>>n;

 for(i=1;i<=n;i++)
  cin>>x[i]>>y[i]>>r[i];

mx=-1;
step=1;
lowp=0;
highp=1000;
lowq=0;
highq=1000;

 for(iter=1;iter<=20;iter++)
 {
  for(p=lowp;p<=highp;p+=step)
   for(q=lowq;q<=highq;q+=step)
   {
    current=GetMaxRadius(p,q);

     if(current>mx)
     {
      mx=current;
      bestp=p;
      bestq=q;
     }
   }

  lowp=Max(0,bestp-step);
  highp=Min(1000,bestp+step);
  lowq=Max(0,bestq-step);
  highq=Min(1000,bestq+step);
  step/=10;
 }

cout<<fixed<<setprecision(12)<<mx<<"\n";

return 0;
}
