#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 103
using namespace std;

struct point
{
    long double x, y;
    point () {}
    point (long double _x, long double _y)
    {
        x = _x;
        y = _y;
    }
};

long double dist(point a, point b)
{
    return sqrt(abs(a.x - b.x) * abs(a.x - b.x) + abs(a.y - b.y) * abs(a.y - b.y));
}

int n;
point pts[MAXN];
long double r[MAXN];

void input()
{
    cin >> n;

    for (int i = 0; i < n; ++i)
    {
        cin >> pts[i].x >> pts[i].y >> r[i];
    }
}

long double best = 0.0;

void solve()
{
    for (long double i = 0.0; i <= 1000.0; i += 0.1)
        for (long double j = 0.0; j <= 1000.0; j += 0.1)
        {
            long double curr = 1414.0;
            for (int idx = 0; idx < n; ++idx)
            {
                long double tmp = dist(pts[idx], point(i * 1.0, j * 1.0));
                long double tmp_r = tmp - r[idx];

                curr = min(curr, tmp_r);

            }
            best = max(best, curr);
        }

    cout << fixed;
    cout << setprecision(9) << best << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    input();
    solve();

    return 0;
}
