#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 150003
#define MAXM 75003
using namespace std;

int n, s, t;

struct node
{
    int lang, instr;
    int clr;

    node () {}

    node (int _lang, int _instr)
    {
        lang = _lang;
        instr = _instr;
        clr = 0;
    }
};

node arr[MAXN];

void input()
{
    cin >> n >> s >> t;

    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i].lang >> arr[i].instr;
    }
}

int best = 0;
vector < vector <int> > v;

int chosen_st[MAXN];
int chosen_l[MAXN];
int chosen_m[MAXN];

vector <int> st_0, st_1, l_0, l_1, m_0, m_1;
int st1 = 0, st0 = 0, l1 = 0, l0 = 0, m1 = 0, m0 = 0;

void check(int idx)
{
    //cout << "___________" << endl;
    vector <int> curr = v[idx];
    int sz = curr.size();

    for (int i = 0; i < sz; ++i)
    {
        //cout << " * " << curr[i] + 1 << endl;
        ++chosen_st[curr[i]];
        ++chosen_l[arr[curr[i]].lang];
        ++chosen_m[arr[curr[i]].instr];
    }
}

void rec(int idx, vector <int> tmp, bool lang[], bool instr[])
{

    //cout << endl;
    //cout << idx << ": " << endl;

    /*for (auto cc: tmp)
        cout << cc << " ";
    cout << endl;*/

    if (idx >= n)
    {
        int sz = tmp.size();

        /*if (sz == 3)
        {
            cout << "* " << sz << endl;

            for (auto cc: tmp)
                cout << cc + 1 << " ";
            cout << endl;
        }*/

        if (sz < best)
            return;

        if (sz == best)
        {
            v.push_back(tmp);
            return;
        }

        if (sz > best)
        {
            best = sz;
            v.clear();
            v.push_back(tmp);
            return;
        }

    }

    rec(idx + 1, tmp, lang, instr);

    if (lang[arr[idx].lang] == 0 && instr[arr[idx].instr] == 0)
    {
        tmp.push_back(idx);
        lang[arr[idx].lang] = 1;
        instr[arr[idx].instr] = 1;
        rec(idx + 1, tmp, lang, instr);
        lang[arr[idx].lang] = 0;
        instr[arr[idx].instr] = 0;
    }
}

bool arr_l[MAXM];
bool arr_m[MAXM];

void init()
{
    int sz = v.size();

    for (int i = 0; i < n; ++i)
    {
        if (chosen_st[i] == 0)
        {
            ++st0;
            st_0.push_back(i);
        }

        if (chosen_st[i] == sz)
        {
            ++st1;
            st_1.push_back(i);
        }
    }

    for (int i = 1; i <= s; ++i)
    {
        if (chosen_l[i] == 0)
        {
            ++l0;
            l_0.push_back(i);
        }

        if (chosen_l[i] == sz)
        {
            ++l1;
            l_1.push_back(i);
        }
    }

    for (int i = 1; i <= t; ++i)
    {
        if (chosen_m[i] == 0)
        {
            ++m0;
            m_0.push_back(i);
        }

        if (chosen_m[i] == sz)
        {
            ++m1;
            m_1.push_back(i);
        }
    }
}

void solve()
{
    vector <int> tr;
    rec(0, tr, arr_l, arr_m);

    int sz = v.size();
    for (int i = 0; i < sz; ++i)
        check(i);

    /*cout << " ++ " << endl;
    for (int i = 0; i < n; ++i)
        cout << chosen_st[i] << " " << chosen_l[i] << " " << chosen_m[i] << endl;
    cout << " ++ " << endl;*/

    init();

    cout << best << " " << st1 << " " << st0 << " " << l1 << " " << l0 << " " << m1 << " " << m0 << endl;

    if (st1 > 0)
    {
        cout << st_1[0] + 1;
        for (int i = 1; i < st1; ++i)
            cout << " " << st_1[i] + 1;
        //cout << endl;
    }
    cout << endl;


    if (st0 > 0)
    {
        cout << st_0[0] + 1;
        for (int i = 1; i < st0; ++i)
            cout << " " << st_0[i] + 1;
        //cout << endl;
    }
    cout << endl;

    if (l1 > 0)
    {
        cout << l_1[0];
        for (int i = 1; i < l1; ++i)
            cout << " " << l_1[i];
        //cout << endl;
    }
    cout << endl;

    if (l0 > 0)
    {
        cout << l_0[0];
        for (int i = 1; i < l0; ++i)
            cout << " " << l_0[i];
        //cout << endl;
    }
    cout << endl;

    if (m1 > 0)
    {
        cout << m_1[0];
        for (int i = 1; i < m1; ++i)
            cout << " " << m_1[i];
        //cout << endl;
    }
    cout << endl;

    if (m0 > 0)
    {
        cout << m_0[0];
        for (int i = 1; i < m0; ++i)
            cout << " " << m_0[i];
        //cout << endl;
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    input();
    solve();

    return 0;
}
