#include<bits/stdc++.h>

#pragma GCC compile("O3")

#define pb push_back
#define fr first
#define sc second
#define bit(x) x&(-x)
#define de(x) cout << #x << " = " << x << endl;
#define all(container) container.begin(), container.end()
#define endl '\n'

using namespace std;

const int MAXN = 16;

int main(){
    ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);
    int n, s, t, A[MAXN][2]; cin >> n >> s >> t;
    for(int i = 1; i <= n; i ++){
        cin >> A[i][0] >> A[i][1];
    }
    int mx_part = 0;
    map<int, vector<pair<set<int>, pair<set<int>, set<int> > >> > mp;
    for(int i = 1; i <= pow(2, n) - 1; i ++){
        int p = 1;
        set<int> part, lang, music;
        /// cout << i << " = ";
        for(int j = 1; j <= n; j ++){
            if(i & p){
                /// cout << j << " ";
                part.insert(j);
                lang.insert(A[j][0]);
                music.insert(A[j][1]);
            }
            p *= 2;
        }
        /// cout << endl;
        if(part.size() == lang.size() && part.size() == music.size()){
            mp[part.size()].pb({part, {lang, music}});
            mx_part = max(mx_part, (int)part.size());
        }
    }
    int freq_part[MAXN] = {0}, freq_lang[MAXN] = {0}, freq_music[MAXN] = {0};
    for(auto x : mp[mx_part]){
        auto part = x.fr;
        auto lang = x.sc.fr;
        auto music = x.sc.sc;
        /// cout << "part: ";
        for(auto x : part){
            /// cout << x << " ";
            ++ freq_part[x];
        }
        /// cout << endl;
        /// cout << "lang: ";
        for(auto x : lang){
            /// cout << x << " ";
            ++ freq_lang[x];
        }
        /// cout << endl;
        /// cout << "music: ";
        for(auto x : music){
            /// cout << x << " ";
            ++ freq_music[x];
        }
        /// cout << endl;
    }
    set<int> an, bn, al, bl, am, bm;
    for(int i = 1; i <= n; i ++){
        /// cout << freq_part[i] << " ";
        if(freq_part[i] == mp[mx_part].size()){
            an.insert(i);
        }
        if(freq_part[i] == 0){
            bn.insert(i);
        }
    }
    /// cout << endl;
    for(int i = 1; i <= s; i ++){
        /// cout << freq_lang[i] << " ";
        if(freq_lang[i] == mp[mx_part].size()){
            al.insert(i);
        }
        if(freq_lang[i] == 0){
            bl.insert(i);
        }
    }
    /// cout << endl;
    for(int i = 1; i <= t; i ++){
        /// cout << freq_music[i] << " ";
        if(freq_music[i] == mp[mx_part].size()){
            am.insert(i);
        }
        if(freq_music[i] == 0){
            bm.insert(i);
        }
    }
    /// cout << endl;
    cout << mx_part << " " << an.size() << " " << bn.size() << " " << al.size() << " " << bl.size() << " " << am.size() << " " << bm.size() << endl;
    for(auto x : an) cout << x << " "; cout << endl;
    for(auto x : bn) cout << x << " "; cout << endl;
    for(auto x : al) cout << x << " "; cout << endl;
    for(auto x : bl) cout << x << " "; cout << endl;
    for(auto x : am) cout << x << " "; cout << endl;
    for(auto x : bm) cout << x << " "; cout << endl;
}
/**
6 4 5
1 1
2 1
3 2
3 3
3 4
4 4
*/
