#include<bits/stdc++.h>

#pragma GCC compile("O3")

#define pb push_back
#define fr first
#define sc second
#define bit(x) x&(-x)
#define de(x) cout << #x << " = " << x << endl;
#define all(container) container.begin(), container.end()
#define endl '\n'

using namespace std;

const int MOD = 1e9 + 7;
const int BASE = 53;
const int MAXN = 1500;

int basePower[MAXN + 5];

struct Hash{
    vector<int> h;
    Hash() {}
    Hash(string t){
        h.pb(t[0]);
        for(int i = 1; i < t.size(); i ++){
            int curr = 1LL * (h.back() + t[i] * basePower[i]) % MOD;
            h.pb(curr);
        }
    }
    int subhash(int l, int r){
        int hl = (l == 0 ? 0 : h[l]);
        int hr = h[r];
        int ret = 1LL * ((hr - hl + MOD) % MOD * basePower[MAXN - l]) % MOD;
        return ret;
    }
};

void init(){
    basePower[0] = 1;
    for(int i = 1; i < MAXN + 5; i ++)
        basePower[i] = (1LL * BASE * basePower[i - 1]) % MOD;
}

int main(){
    init();
    ios_base::sync_with_stdio(0); cin.tie(NULL); cout.tie(NULL);
    string t; cin >> t;
    Hash T = Hash(t);
    vector<int> v;
    for(int i = 0; i < t.size(); i ++){
        for(int j = i; j < t.size(); j ++){
            v.pb(T.subhash(i, j));
        }
    }
    sort(all(v));
    auto it = unique(all(v));
    v.resize(distance(v.begin(), it));
    cout << v.size() << endl;
}
