#include<bits/stdc++.h>
#define null nullptr
using namespace std;
struct okr{float x,y,r;};
struct vec{float dx,dy;};
struct point{float x,y;};
point tsl(point p,vec v)
{
    return {p.x+v.dx,p.y+v.dy};
}
float dist(point a,point b)
{
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
vec rot(vec v,float a)
{
    float b=atan(v.dy/v.dx);
    b+=a;
    float l=dist({0,0},{v.dx,v.dy});
    return {l*cos(b),l*sin(b)};
}
vec add(vec a,vec b)
{
    return {a.dx+b.dx,a.dy+b.dy};
}
vec mul(float a,vec b)
{
    return {a*b.dx,a*b.dy};
}
float area(point a,point b,point c)
{
    float d1,d2,d3;
    d1=dist(a,b);
    d2=dist(c,b);
    d3=dist(a,c);
    float p=(d1+d2+d3)/2;
    //return sqrt(p*(p-d1)*(p-d2)*(p-d3));
    return fabs(a.x*b.y-a.y*b.x+b.x*c.y-b.y*c.x+c.x*a.y-c.y*a.x)/2;
}
pair<float,float> solve(float a,float b,float c)
{
    float d=b*b-4*a*c;
    if(d<0) return {69,69};
    return {(-b-sqrt(d))/(2*a),(-b+sqrt(d))/(2*a)};
}
pair<point,point> intersect(okr a,okr b)
{
    float c,d;
    c=(a.y-b.y)/(b.x-a.x);
    d=a.x+b.x+(b.y*b.y-a.y*a.y+a.r*a.r-b.r*b.r)/(b.x-a.x);
    auto ys=solve(c*c+1, c*d-c*a.x-a.y, d*d-a.x*a.x-2*d*a.x+a.y*a.y-a.r*a.r);
    if(ys.first==69&&ys.second==69) return {{69,69},{69,69}};
    return {{c*ys.first+d,ys.first}, {c*ys.second+d,ys.second}};
}
int n;
okr o[128];
bool checkc(point a)
{
    return (a.x>=0)&&(a.y>=0)&&(a.x<=1000)&&(a.y<=1000);
}
bool checki(okr a)
{
    for(int i=0;i<n;i++)
    {
        if(dist({a.x,a.y},{o[i].x,o[i].y})-a.r+o[i].r<-0.000000001) return 0;
    }
    return 1;
}
bool check(float r)
{
    for(int i=0;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            auto p=intersect({o[i].x,o[i].y,r+o[i].r},{o[j].x,o[j].y,o[j].r+r});
            if(p.first.x==69&&p.first.y==69&&p.second.x==69&&p.second.y==69) continue;
            if(checkc(p.first)&&checki({p.first.x,p.first.y,r})) return 1;
            if(checkc(p.second)&&checki({p.second.x,p.second.y,r})) return 1;
        }
    }
    return 0;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cout<<setprecision(12)<<fixed;
    cin>>n;
    for(int i=0;i<n;i++)
    {
        cin>>o[i].x>>o[i].y>>o[i].r;
    }
    float l=0,r=1000,ans=0;
    while(1)
    {
        float mid=(l+r)/2;
        //cout<<" --  "<<mid<<endl;
        if(check(mid))
        {
            if(mid-ans<0.000000001) break;
            ans=mid; l=mid;
        }
        else r=mid;
    }
    cout<<ans<<endl;
    return 0;
}
/**

7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8

*/
