#include<bits/stdc++.h>
using namespace std;

#define MAXN 150000
#define MAXLM 75000

#define s1 first
#define s2 second

long long countN[MAXN];
long long countL[MAXLM], countM[MAXLM];

int n, l, m;
pair<int, int> skills[MAXN];

set<int> takenL, takenM;
int maxNum=0, var=0;

void solve(int student, int num, vector<int> current)
{
    if(student==n)
    {
        if(num<maxNum) return;
        if(num==maxNum) var++;

        if(num>maxNum)
        {
            var=1;
            maxNum=num;
            for(int i=0; i<n; ++i) countN[i]=0;
        }

        for(int i=0; i<current.size(); ++i)
        {
            countN[current[i]]++;
        }
        return;
    }

    solve(student+1, num, current);

    if(takenL.count(skills[student].s1) || takenM.count(skills[student].s2))
        return;

    takenL.insert(skills[student].s1);
    takenM.insert(skills[student].s2);
    current.push_back(student);

    solve(student+1, num+1, current);

    takenL.erase(skills[student].s1);
    takenM.erase(skills[student].s2);
}

int An, Bn, Al, Bl, Am, Bm;
vector<int> Anv, Bnv, Alv, Blv, Amv, Bmv;

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>l>>m;
    for(int i=0; i<n; ++i)
    {
        cin>>skills[i].s1>>skills[i].s2;
    }

    solve(0, 0, {});

    cout<<maxNum<<" ";

    for(int i=0; i<n; ++i)
    {
        if(countN[i]==var)
        {
            An++;
            Anv.push_back(i+1);
        }

        if(countN[i]==0)
        {
            Bn++;
            Bnv.push_back(i+1);
        }

        countL[skills[i].s1]+=countN[i];
        countM[skills[i].s2]+=countN[i];
    }

    cout<<An<<" "<<Bn<<" ";

    for(int i=1; i<=l; ++i)
    {
        if(countL[i]==var)
        {
            Al++;
            Alv.push_back(i);
        }

        if(countL[i]==0)
        {
            Bl++;
            Blv.push_back(i);
        }
    }

    cout<<Al<<" "<<Bl<<" ";

    for(int i=1; i<=m; ++i)
    {
        if(countM[i]==var)
        {
            Am++;
            Amv.push_back(i);
        }

        if(countL[i]==0)
        {
            Bm++;
            Bmv.push_back(i);
        }
    }

    cout<<Am<<" "<<Bm<<endl;

    if(Anv.size()>0) cout<<Anv[0];
    for(int i=1; i<Anv.size(); i++) cout<<" "<<Anv[i];
    cout<<endl;

    if(Bnv.size()>0) cout<<Bnv[0];
    for(int i=1; i<Bnv.size(); i++) cout<<" "<<Bnv[i];
    cout<<endl;

    if(Alv.size()>0) cout<<Alv[0];
    for(int i=1; i<Alv.size(); i++) cout<<" "<<Alv[i];
    cout<<endl;

    if(Blv.size()>0) cout<<Blv[0];
    for(int i=1; i<Blv.size(); i++) cout<<" "<<Alv[i];
    cout<<endl;

    if(Amv.size()>0) cout<<Amv[0];
    for(int i=1; i<Amv.size(); i++) cout<<" "<<Amv[i];
    cout<<endl;

    if(Bmv.size()>0) cout<<Bmv[0];
    for(int i=1; i<Bmv.size(); i++) cout<<" "<<Bmv[i];
    cout<<endl;

    return 0;
}
