#include <bits/stdc++.h>
using namespace std;
//T+N
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll mod = 1e9 + 7;
template<class T, class T2> inline bool chkmax(T &a, const T2 &b) {return a < b ? a = b, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &a, const T2 &b) {return a > b ? a = b, 1 : 0;}
template<class T> inline void fix(T &a) {if(a >= mod | a <= -mod) {a %= mod;} if(a < 0) {a += mod;}}
#pragma GCC optimize("Ofast")

ld dist(ld x, ld y, ld a, ld b) {
    return (x - a) * (x - a) + (y - b) * (y - b);
}

ld sqr(ld x, ld y, ld a, ld b) {
    return sqrt(dist(x, y, a, b));
}

const int MAX_N = 110;
ld x[MAX_N], y[MAX_N], rad[MAX_N];
int n;

ld ret = 0;

ld f(ld a, ld b) {
    ld best = mod;
    for(int i = 0; i < n; i ++) {
        ld curr = sqr(a, b, x[i], y[i]) - rad[i];
        chkmin(best, curr);
        if(best < 1e-9) {return 0;}
    }
    chkmax(ret, best);
    return best;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> x[i] >> y[i] >> rad[i];
    }
    for(ld a = 0; a <= 1000; a += 0.01) {
        for(ld b = 0; b <= 1000; b += 0.01) {
            f(a, b);
        }
    }
    cout << fixed << setprecision(10);
    cout << ret << endl;
    return 0;
}

