#include <bits/stdc++.h>
using namespace std;
//T+N
#define endl "\n"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ll mod = 1e9 + 7;
template<class T, class T2> inline bool chkmax(T &a, const T2 &b) {return a < b ? a = b, 1 : 0;}
template<class T, class T2> inline bool chkmin(T &a, const T2 &b) {return a > b ? a = b, 1 : 0;}
template<class T> inline void fix(T &a) {if(a >= mod || a <= -mod) {a %= mod;} if(a < 0) {a += mod;}}

const int MAX_N = 1e4 + 10;
vector<pair<int, int> > g[MAX_N];
int used[MAX_N], blocked[MAX_N], cant[MAX_N];
bool always[MAX_N], never[MAX_N];
int n, s, t;
int alwaysVert[MAX_N];

bool kuhn(ll x, bool ser) {
    if(used[x] == -1 && ser) {return true;}
    if(cant[x]) {return false;}
    for(auto it : g[x]) {
        if(blocked[it.second] || used[it.first] == x) {continue;}
        if(used[it.first] == -1 || kuhn(used[it.first], 1)) {
            used[it.first] = x;
            used[x] = it.first;
            return true;
        }
    }
    return false;
}


void prepare() {
    for(int i = 0; i < n; i ++) {
        blocked[i] = false;
    }
    for(int i = 0; i < s + t + 1; i ++) {
        used[i] = -1;
        cant[i] = false;
    }
}

int l[MAX_N], r[MAX_N];

int match() {
    int now = 0;
    for(int i = 1; i <= s; i ++) {
        kuhn(i, 0);
    }
    for(int i = 1; i <= s; i ++) {
        if(used[i] != -1) {
            //cout << "Got " << i << endl;
            now ++;
        }
    }
    return now;
}

signed main() {
    //ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    cin >> n >> s >> t;
    for(int i = 0; i < n; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back({b + s, i});
        g[b + s].push_back({a, i});
        l[i] = a;
        r[i] = b + s;
    }
    return 0;
    prepare();
    int best = match();
    //cout << best << endl;
    for(int i = 0; i < n; i ++) {
        prepare();
        blocked[i] = true;
        if(match() != best) {
            always[i] = true;
            //cout << "Vinagi " << i << endl;
        }
        //cout << endl;
        prepare();
        cant[l[i]] = true;
        used[l[i]] = r[i];
        used[r[i]] = l[i];
        cant[r[i]] = true;
        if(match() == best) {
            never[i] = true;
        }
    }
    for(int i = 1; i <= s + t; i ++) {
        prepare();
        for(auto it : g[i]) {
            blocked[it.second] = true;
        }
        cant[i] = true;
        used[i] = i;
        int now = match();
        if(i <= s) {now --;}
        if(now != best) {
            alwaysVert[i] = true;
        }
    }


    vector<int> ansAL[3], ansNEV[3];
    for(int i = 0; i < n; i ++) {
        if(always[i]) {
            ansAL[0].push_back(i + 1);
        } else if(!never[i]) {
            ansNEV[0].push_back(i + 1);
        }
    }
    for(int i = 1; i <= s + t; i ++) {
        int gr = 0;
        if(alwaysVert[i] == true) {
            if(i <= s) {
                ansAL[1].push_back(i);
            } else {
                ansAL[2].push_back(i - s);
            }
            continue;
        }
        for(auto it : g[i]) {
            if(never[it.second]) {
                gr = 1;
            }
        }
        if(gr == 0) {
            if(i <= s) {
                ansNEV[1].push_back(i);
            } else {
                ansNEV[2].push_back(i - s);
            }
        }
    }

    cout << best << " ";
    for(int i = 0; i < 3; i ++) {
        cout << ansAL[i].size() << " " << ansNEV[i].size() << " ";
    }
    cout << endl;
    for(int i = 0; i < 3; i ++) {
        for(auto it : ansAL[i]) {
            cout << it << " ";
        }
        cout << endl;
        for(auto it : ansNEV[i]) {
            cout << it << " ";
        }
        cout << endl;
    }
    return 0;
}

