#include <iostream>
#include <cmath>
using namespace std;

int n;
long double x[1024], y[1024], r[1024];

long double tryx[4], tryy[4];
long double rmax;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    tryx[1] = 1000;
    tryx[3] = 1000;
    tryy[2] = 1000;
    tryy[3] = 1000;

    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> x[i] >> y[i] >> r[i];
    }

    for(int i = 0; i < 4; i++){
        long double r2kv = ((tryx[i]-x[0])*(tryx[i]-x[0]) + (tryy[i]-y[0])*(tryy[i]-y[0]));
        long double r2 = sqrt(r2kv)-r[0];
        if(r2 > rmax){
            rmax = r2;
        }
    }

    cout << rmax << endl;
    return 0;
}
