#include <iostream>
#include <algorithm>
#include <cstring>
using namespace std;

char inp[2048], x;
long long q;
long long t;
long long order[2048], suffixPlace[2][2048];
long long n, i;
long long c;
long long ans;

bool cmp(long long A, long long B)
{
    if(i > 0) {
        if(suffixPlace[0][A] != suffixPlace[0][B]) return false;
        if(A-i <= 0 && B-i > 0) return true;
        if(A-i > 0 && B-i <= 0) return false;
        if(A-i <= 0 && B-i <= 0) return false;
        return inp[n-A+i] < inp[n-B+i];
    } else {
        return inp[n-A] < inp[n-B];
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    for(long long f = 1; f <= 2048; f++) {
        order[f-1] = f;
    }

    cin >> inp;
    cin >> q;

    n = strlen(inp);

    for(i = 0; i < n; i++) {
        c = 0;
        sort(order, order+n, cmp);
        if(i > 0) {
            for(long long k = 1; k < n; k++) {
                if(suffixPlace[0][order[k]] != suffixPlace[0][order[k-1]] || order[k]-i <= 0 || order[k-1]-i <= 0 || inp[n-order[k]+i] != inp[n-order[k-1]+i]) {
                    c++;
                }
                suffixPlace[1][order[k]] = c;
            }
            /*for(long long k = 0; k < n; k++) {
                cout << order[k] << " ";
            }*/
        } else {
            for(long long k = 1; k < n; k++) {
                if(inp[n-order[k]] != inp[n-order[k-1]]){
                    c++;
                }
                suffixPlace[1][order[k]] = c;

            }
        }
        swap(suffixPlace[0], suffixPlace[1]);
        c++;
        c -= i;
        ans += c;
        //cout << c << endl;
    }

    cout << ans << endl;

return 0;
}
