#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

struct circle
{
    double x, y, r;
};

const int maxn = 1e3 + 3;
const double eps = 0.01;

int n;
circle circles[maxn];
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    cin >> circles[i].x >> circles[i].y >> circles[i].r;
}

bool can(double x)
{
    for (double i = x; i <= 1000 - x; i += 0.1)
        for (double j = x; j <= 1000 - x; j += 0.1)
    {
        bool is = true;
        for (int k = 1; k <= n; k++)
        {
           double r = (i - circles[k].x) * (i - circles[k].x) + (j - circles[k].y) * (j - circles[k].y) - (x + circles[k].r) * (x + circles[k].r);
           if (r < -eps)
           {
               is = false;
               break;
           }
        }

        if (is)
            return true;
    }

    return false;
}

void solve()
{
    double low = 0, high = 500;
    while (high - low > eps)
    {
        double mid = (low + high) / 2.0;
        if (can(mid))
        low = mid;

        else
        high = mid;
    }

    cout << low << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
7
42.1337 13.666 191.17
543.21 765.432 55.555
987.987 666.666 321.321
0 1000 100
666.666 66.66 16.6
133.331 666.666666666 123.321
888.8 88.8 8.8
*/
