#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")
using namespace std;

const int maxn = 2e5 + 3;
const int base = 29;
const int mod = 1e9 + 7;

string s;
int q, sz;
void read()
{
    cin >> s >> q;
    sz = (int)s.size();
}

long long pr[maxn], base_pow[maxn];
long long get(int l, int r)
{
    return (pr[r] - pr[l-1] * base_pow[r-l+1] % mod + mod) % mod;
}

int lcp(int i, int j)
{
    int low = 0, high = sz - max(i, j) + 1;
    while (low < high)
    {
        int mid = (low + high + 1) / 2;
        if (get(i, i + mid - 1) == get(j, j + mid - 1))
            low = mid;

        else
            high = mid - 1;
    }

    return low;
}

struct suffix
{
    int idx;
    bool operator < (const suffix &t) const
    {
        int curr_lcp = lcp(idx, t.idx);
        if (curr_lcp == sz - max(idx, t.idx) + 1)
           return idx > t.idx;

        return s[idx + curr_lcp - 1] < s[t.idx + curr_lcp - 1];
    }
};

long long sum = 0;
long long get(int l)
{
    return (sz - l + 1) * (sz - l + 2) / 2 - sum;
}

void solve()
{
    for (int i = 1; i <= sz; i++)
        pr[i] = (pr[i-1] * base + s[i-1] - 'a') % mod;

    base_pow[0] = 1;
    for (int i = 1; i < maxn; i++)
        base_pow[i] = base_pow[i-1] * base % mod;

    int l = 1;
    set <suffix> con;
    for (int i = 1; i <= sz; i++)
    con.insert({i});

    for (auto it = con.begin(); it != prev(con.end()); it++)
        sum += lcp(it->idx, next(it)->idx);

    cout << get(l) << " ";
    for (int test = 1; test <= q; test++)
    {
        int type;
        cin >> type;

        if (type == 2)
        {
            auto it = con.lower_bound({l});
            if (it == con.begin())
                sum -= lcp(it->idx, next(it)->idx);

            else
                if (it == prev(con.end()))
                sum -= lcp(it->idx, prev(it)->idx);

            else
            {
                sum -= lcp(it->idx, prev(it)->idx);
                sum -= lcp(it->idx, next(it)->idx);
                sum += lcp(prev(it)->idx, next(it)->idx);
            }

            con.erase(it);
            l++;
        }

        else
        {
            char let;
            cin >> let;

            s += let;
            sz++;
            pr[sz] = (pr[sz-1] * base + s[sz-1] - 'a') % mod;

            auto it = con.insert({sz}).first;
            if (it == con.begin())
                sum += lcp(it->idx, next(it)->idx);

            else
                if (it == prev(con.end()))
                sum += lcp(it->idx, prev(it)->idx);

            else
            {
                sum += lcp(it->idx, prev(it)->idx);
                sum += lcp(it->idx, next(it)->idx);
                sum -= lcp(prev(it)->idx, next(it)->idx);
            }
        }

        cout << get(l) << " ";
    }

    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
