#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
using namespace std;

struct kryg{
    double x, y, r;

    kryg():
        x(0), y(0), r(0) {};

    kryg(double x, double y, double r):
        x(x), y(y), r(r) {};
};
const double eps = 1e-10;
int n;
double glo;
double x, y;
kryg a[128];

inline double razst(double x1, double y1){
    return sqrt((x - x1)*(x - x1)+(y - y1)*(y - y1));
}
inline double vibecheck(double x2, double y2, double x1, double y1){
    return sqrt((x2 - x1)*(x2 - x1)+(y2 - y1)*(y2 - y1));
}
inline double ultravibecheckx(double x1, double y1, double x2, double y2){
    double m1, m2;
    while(x2-x1>eps){
        m1=2000, m2=2000;
        for(int i=0;i<n;++i){
            m1 = min(m1, vibecheck(x1,y1,a[i].x, a[i].y) - a[i].r);
            m2 = min(m2, vibecheck(x2,y2,a[i].x, a[i].y) - a[i].r);
        }
        if(m1>m2) x2-=((x2-x1)/3);
        else x1+=((x2-x1)/3);
    }
    return m1;
}
inline double ultravibechecky(double x1, double y1, double x2, double y2){
    double m1, m2;
    while(x2-x1>eps){
        m1=2000, m2=2000;
        for(int i=0;i<n;++i){
            m1 = min(m1, vibecheck(x1,y1,a[i].x, a[i].y) - a[i].r);
            m2 = min(m2, vibecheck(x2,y2,a[i].x, a[i].y) - a[i].r);
        }
        if(m1>m2) y2-=((y2-y1)/3);
        else y1+=((y2-y1)/3);
    }
    return m1;
}


int main(){
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin>>n;
    for(int i=0; i<n; ++ i){
        double x, y, r;
        cin>>x>>y>>r;
        a[i] = {x, y, r};
    }
    double r1 = 2000;
    for(int i=0;i<n;++i){
        r1 = min(r1, razst(a[i].x, a[i].y)-a[i].r);
    }
    glo = max(glo, r1);
    r1 = 2000;
    //cout<<setprecision(15)<<glo<<'\n';
    x = 1000;
    for(int i=0;i<n;++i){
        r1 = min(r1, razst(a[i].x, a[i].y)-a[i].r);
    }

    glo = max(glo, r1);r1 = 2000;
    //cout<<setprecision(15)<<glo<<'\n';
    y= 1000;
    for(int i=0;i<n;++i){
        r1 = min(r1, razst(a[i].x, a[i].y)-a[i].r);
    }

    glo = max(glo, r1);r1 = 2000;
    //cout<<setprecision(15)<<glo<<'\n';
    x = 0;
    for(int i=0;i<n;++i){
        r1 = min(r1, razst(a[i].x, a[i].y)-a[i].r);
    }
    glo = max(glo, r1);
    glo = max (glo, ultravibecheckx(0, 0, 1000, 0));cout<<glo<<'\n';
    glo = max (glo, ultravibecheckx(0, 1000, 1000, 1000));cout<<glo<<'\n';
    glo = max (glo, ultravibechecky(0, 0, 0, 1000));cout<<glo<<'\n';
    glo = max (glo, ultravibecheckx(1000, 0, 1000, 1000));
    cout<<setprecision(15)<<glo<<'\n';
    return 0;
}
